table_columns = {
    "action_general_view": (
        "action_id",
        "action_stars",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "destination_subsystem_id",
        "destination_system_id",
        "end_timestamp",
        "expiration_unit",
        "expiration_value",
        "filename",
        "folder_name",
        "function_module",
        "function_name",
        "is_queue_action",
        "is_smartlink_action",
        "is_test_data",
        "name",
        "package_name",
        "source_system_id",
        "start_timestamp",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_logger_view": (
        "action_id",
        "count(logger.action_id)",
        "destination.system.title",
        "name",
        "source.system.title"
    ),
    "action_table": (
        "action_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "destination_subsystem_id",
        "destination_system_id",
        "dialog_workflow_script_id",
        "end_timestamp",
        "expiration_unit",
        "expiration_value",
        "filename",
        "folder_name",
        "function_module",
        "function_name",
        "is_queue_action",
        "is_smartlink_action",
        "is_test_data",
        "name",
        "package_name",
        "source_system_id",
        "start_timestamp",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_view": (
        "action_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "filename",
        "folder_name",
        "function_module",
        "function_name",
        "is_queue_action",
        "is_smartlink_action",
        "name",
        "package_name",
        "start_timestamp",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_category_ml_table": (
        "action_item_category_id",
        "action_item_category_ml_id",
        "body",
        "category_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "start_timestamp",
        "subeject",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_category_table": (
        "action_item_category_table_id",
        "channel_category_id",
        "version"
    ),
    "action_item_general_view": (
        "action_id",
        "action_item_id",
        "action_item_type_id",
        "active_main_profile_id",
        "activity_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "other_group_id",
        "other_person_id",
        "other_profile_id",
        "passive_main_contact_id",
        "passive_main_profile_id",
        "ranking",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "action_item_ml_table": (
        "action_item_id",
        "action_item_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_ml_view": (
        "action_item_id",
        "action_item_ml_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_priority_table": (
        "action_item_priority_id",
        "default_action_item_ranking"
    ),
    "action_item_priority_view": (
        "action_item_priority_id",
        "default_action_item_ranking"
    ),
    "action_item_table": (
        "action_id",
        "action_item_id",
        "action_item_type_id",
        "active_main_profile_id",
        "activity_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "other_group_id",
        "other_person_id",
        "other_profile_id",
        "passive_main_contact_id",
        "passive_main_profile_id",
        "ranking",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "action_item_view": (
        "action_id",
        "action_item_id",
        "action_item_type_id",
        "active_main_profile_id",
        "activity_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "other_group_id",
        "other_person_id",
        "other_profile_id",
        "passive_main_contact_id1",
        "passive_main_profile_id",
        "ranking",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "action_item_profile_table": (
        "action_item_id",
        "action_item_ml_id",
        "action_item_profile_id",
        "active_profile_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "passive_contact_id",
        "passive_profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_profile_table_old": (
        "action_item_id",
        "action_item_profile_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "profile_id1",
        "profile_id2",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_profile_view": (
        "action_item_id",
        "action_item_ml_id",
        "action_item_profile_id",
        "active_profile_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "passive_contact_id",
        "passive_profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_type_ml_table": (
        "action_item_type_id",
        "action_item_type_ml_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_item_type_table": (
        "action_item_type_id",
        "channel_type_id",
        "version"
    ),
    "action_star_subscription_table": (
        "action_id",
        "action_star_subscription_id",
        "action_stars",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "number",
        "start_timestamp",
        "subscription_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "action_star_subscription_view": (
        "action_id",
        "action_star_subscription_id",
        "action_stars",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "number",
        "start_timestamp",
        "subscription_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "activity_group_location_occurrence_profile_ml_table": (
        "activity_location_occurrence_profile_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "lang_code",
        "start_timestamp",
        "title",
        "title_approved",
        "updated_timestamp",
        "updated_user_id"
    ),
    "activity_group_location_occurrence_profile_table": (
        "activity_group_location_occurrence_profile_id",
        "activity_id",
        "activity_list_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "group_list_id",
        "location_id",
        "location_list_id",
        "occurrence_id",
        "occurrence_list_id",
        "profile_id",
        "profile_list_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "advertisement_campaign_table": (
        "advertisement_campaign_id",
        "advertisement_id",
        "campaign_id"
    ),
    "advertisement_message_template_table": (
        "advertisement_id",
        "advertisement_message_template_id",
        "message_template_id"
    ),
    "advertisement_profile": (
        "advertisment_id",
        "duration_ms",
        "id",
        "is_clicked",
        "profile_id"
    ),
    "api_call_general_view": (
        "api_call_id",
        "api_type.name",
        "api_type_id",
        "created_timestamp",
        "created_user_id",
        "endpoint_url",
        "handle",
        "http_status_code",
        "incoming_message_json",
        "is_network",
        "is_test_data",
        "outgoing_body_json",
        "outgoing_body_significant_fields_hash",
        "outgoing_header_json",
        "response_body_json",
        "session_token",
        "user_external_id",
        "username"
    ),
    "api_call_group_by_api_type_date_view": (
        "api_type_id",
        "api_type_name",
        "COUNT(*)",
        "DATE(created_timestamp)"
    ),
    "api_call_group_by_date_view": (
        "COUNT(*)",
        "DATE(created_timestamp)"
    ),
    "api_call_group_without_user_extenal_id_by_date_view": (
        "COUNT(*)",
        "DATE(created_timestamp)"
    ),
    "api_call_table": (
        "api_call_id",
        "api_type_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "endpoint_url",
        "http_status_code",
        "incoming_message_json",
        "is_network",
        "is_test_data",
        "number",
        "outgoing_body_json",
        "outgoing_body_significant_fields_hash",
        "outgoing_header_json",
        "response_body_json",
        "session_token",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id"
    ),
    "api_call_view": (
        "api_call_id",
        "api_type_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "endpoint_url",
        "http_status_code",
        "incoming_message_json",
        "is_network",
        "is_test_data",
        "number",
        "outgoing_body_json",
        "outgoing_body_significant_fields_hash",
        "outgoing_header_json",
        "response_body_json",
        "session_token",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id"
    ),
    "api_limit_table": (
        "api_limit_id",
        "api_type_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "external_limit_code",
        "external_limit_name",
        "hard_limit_unit",
        "hard_limit_value",
        "region",
        "soft_limit_unit",
        "soft_limit_value",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "url_to_see_the limit",
        "user_external_id"
    ),
    "api_limit_view": (
        "api_limit_id",
        "api_type_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "external_limit_code",
        "external_limit_name",
        "hard_limit_unit",
        "hard_limit_value",
        "region",
        "soft_limit_unit",
        "soft_limit_value",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "url_to_see_the limit",
        "user_external_id"
    ),
    "api_parameter_table": (
        "api_parameters_id",
        "api_type_id",
        "name",
        "type"
    ),
    "api_type_field_table": (
        "api_type_field_id",
        "api_type_id",
        "field_name",
        "field_significant"
    ),
    "api_type_field_view": (
        "api_type_field_id",
        "api_type_id",
        "field_name",
        "field_significant"
    ),
    "api_type_table": (
        "action_id",
        "api_type_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "endpoint_url",
        "expiration_unit",
        "expiration_value",
        "from_subsystem_id",
        "from_system_id",
        "github_repo",
        "hander_function_name",
        "http_method",
        "interval_max_seconds",
        "interval_min_seconds",
        "is_enabled",
        "is_test_data",
        "message_channel_provider_id",
        "name",
        "start_timestamp",
        "status_code_when_not_found",
        "to_subsystem_id",
        "to_system_id",
        "type",
        "updated_timestamp",
        "updated_user_id",
        "usage_and_billing_url"
    ),
    "api_type_view": (
        "action_id",
        "api_type_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "endpoint_url",
        "expiration_unit",
        "expiration_value",
        "from_subsystem_id",
        "from_system_id",
        "github_repo",
        "hander_function_name",
        "http_method",
        "interval_max_seconds",
        "interval_min_seconds",
        "is_enabled",
        "is_test_data",
        "message_channel_provider_id",
        "name",
        "start_timestamp",
        "status_code_when_not_found",
        "to_subsystem_id",
        "to_system_id",
        "type",
        "updated_timestamp",
        "updated_user_id",
        "usage_and_billing_url"
    ),
    "api_type_user_external_table": (
        "api_type_id",
        "api_type_user_external_id",
        "environment_id",
        "user_external_id"
    ),
    "api_type_user_external_view": (
        "api_type_id",
        "api_type_user_external_id",
        "environment_id",
        "user_external_id"
    ),
    "calendar_item_profile_person_table": (
        "attendee_status_id",
        "calendar_item_id",
        "calendar_item_profile_person_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_mandatory",
        "is_optional",
        "is_test_data",
        "number",
        "person_id",
        "profile_id",
        "profile_person_status_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "calendar_profile_table": (
        "attendee_status_id",
        "calendar_item_id",
        "calendar_profile_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_mandatory",
        "is_optional",
        "is_test_data",
        "number",
        "person_id",
        "profile_id",
        "profile_person_status_id",
        "resource_id",
        "resource_status_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "campaign_campaign_type_table": (
        "campaign_campaign_type_id",
        "campaign_id",
        "campaign_type_id"
    ),
    "campaign_general_view": (
        "campaign_id",
        "created_timestamp",
        "created_user_id",
        "criteria_id_old",
        "days_of_week",
        "default_sender_profile_id",
        "dialog_workflow_script_id",
        "end_hour",
        "end_timestamp",
        "is_dialog_workflow",
        "is_test_data",
        "max_audience",
        "max_exposure_per_day",
        "message_template_id_old",
        "minimal_days_between_messages_to_the_same_recipient",
        "name",
        "occurrence_id",
        "start_hour",
        "start_state_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "campaign_ml_table": (
        "campaign_id",
        "campaign_ml_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "campaign_status_ml_table": (
        "campaign_status_id",
        "campaign_status_ml_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "campaign_status_table": (
        "campaign_status_id"
    ),
    "campaign_table": (
        "campaign_id",
        "content_set_id",
        "created_timestamp",
        "created_user_id",
        "criteria_id_old",
        "days_of_week",
        "default_sender_profile_id",
        "dialog_workflow_script_id",
        "end_hour",
        "end_timestamp",
        "is_dialog_workflow",
        "is_test_data",
        "max_audience",
        "max_exposure_per_day",
        "message_template_id_old",
        "minimal_days_between_messages_to_the_same_recipient",
        "name",
        "occurrence_id",
        "start_hour",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "campaign_type_table": (
        "campaign_type_id",
        "name"
    ),
    "campaign_view": (
        "campaign_id",
        "days_of_week",
        "end_hour",
        "end_timestamp",
        "is_test_data",
        "max_audience",
        "max_exposure_per_day",
        "message_template_id_old",
        "minimal_days_between_messages_to_the_same_recipient",
        "name",
        "occurrence_id",
        "start_hour",
        "start_timestamp"
    ),
    "campaign_criteria_set_general_view": (
        "campaign.name",
        "campaign_criteria_set_id",
        "campaign_id",
        "criteria_id_old",
        "criteria_set.name",
        "criteria_set_id",
        "is_test_data"
    ),
    "campaign_criteria_set_table": (
        "campaign_criteria_set_id",
        "campaign_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "criteria_id_old",
        "criteria_set_id",
        "end_timestamp",
        "is_test_data",
        "max_recipients_per_campaign_criteria_set",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "campaign_criteria_set_view": (
        "campaign_criteria_set_id",
        "campaign_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "criteria_id_old",
        "criteria_set_id",
        "end_timestamp",
        "is_test_data",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "campaign_group_table": (
        "advertisement_id",
        "group_id",
        "id"
    ),
    "campaign_group_list_table": (
        "advertisement_id",
        "group_list_id",
        "id"
    ),
    "campaign_message_profile_general_view": (
        "campaign_id",
        "campaign_message_profile_id",
        "channel_id",
        "channel_id_old",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "last_dialog_workflow_state_id",
        "message_id",
        "number",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "campaign_message_profile_table": (
        "campaign_id",
        "campaign_message_profile_id",
        "channel_id_old",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "last_dialog_workflow_state_id",
        "message_id",
        "number",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "campaign_message_profile_view": (
        "campaign_id",
        "campaign_message_profile_id",
        "channel_id_old",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "last_dialog_workflow_state_id",
        "message_id",
        "number",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "campaign_message_template_table": (
        "campaign_id",
        "campaign_message_template_id",
        "message_template_id",
        "percent"
    ),
    "campaign_message_template_view": (
        "campaign_id",
        "campaign_message_template_id",
        "message_template_id",
        "percent"
    ),
    "campaign_smartlink_table": (
        "campaign_id",
        "campaign_smartlink_id",
        "smartlink_id"
    ),
    "campaign_smartlink_view": (
        "campaign_id",
        "campaign_smartlink_id",
        "smartlink_id"
    ),
    "campaign_traction_table": (
        "campaign_id",
        "campaign_traction_id",
        "contact_id",
        "is_exposed_deal_details",
        "message_id",
        "person_id",
        "smartlink_id"
    ),
    "component_table": (
        "api_type",
        "component_category",
        "component_id",
        "component_type",
        "created_timestamp",
        "created_user_id",
        "developer_email",
        "developer_profile_id",
        "end_timestamp",
        "github_repo",
        "name",
        "parent_component_id",
        "programming_language",
        "programming_language_id",
        "repo_name",
        "start_timestamp",
        "testing_framework",
        "updated_timestamp",
        "updated_user_id"
    ),
    "component_view": (
        "api_type",
        "component_category",
        "component_id",
        "component_type",
        "github_repo",
        "name",
        "parent_component_id",
        "programming_language",
        "programming_language_id",
        "repo_name",
        "testing_framework"
    ),
    "programming_language_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "name",
        "programming_language_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_ml_table": (
        "contact_id",
        "contact_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_potential_view": (
        "contact_location_id",
        "contact_ml.titile",
        "contact_ml_id",
        "coordinate",
        "created_user_id",
        "entity_id",
        "entity_type_id",
        "lang_code",
        "location_id",
        "title",
        "updated_timestamp",
        "visibility_id"
    ),
    "contact_recent_general_view": (
        "contact_id",
        "email1",
        "first_name",
        "last_name",
        "updated_timestamp"
    ),
    "contact_table": (
        "account_name",
        "additional_name",
        "address1_city",
        "address1_country",
        "address1_postal_code",
        "address1_state",
        "address1_street",
        "address2_city",
        "address2_country",
        "address2_postal_code",
        "address2_state",
        "address2_street",
        "anniversary",
        "birthday",
        "cira",
        "contact_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "data_source_instance_id",
        "day",
        "department",
        "display_as",
        "email1",
        "email2",
        "email3",
        "end_timestamp",
        "first_name",
        "full_name",
        "identifier",
        "is_test_data",
        "job_title",
        "job_title_id",
        "job_title_ml_id",
        "last_name",
        "last_sync_timestamp",
        "main_profile_id",
        "month",
        "name_prefix",
        "name_suffix",
        "nickname",
        "notes",
        "number",
        "organization",
        "organization_profile_id",
        "original_first_name",
        "original_last_name",
        "owner_profile_id",
        "person_id",
        "phone1",
        "phone2",
        "phone3",
        "photo_file_name",
        "photo_url",
        "source",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "uploaded_timestamp",
        "visibility_id",
        "website1",
        "website2",
        "website3",
        "year"
    ),
    "contact_view": (
        "account_name",
        "additional_name",
        "address1_city",
        "address1_country",
        "address1_postal_code",
        "address1_state",
        "address1_street",
        "address2_city",
        "address2_country",
        "address2_postal_code",
        "address2_state",
        "address2_street",
        "anniversary",
        "birthday",
        "cira",
        "contact_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "data_source_instance_id",
        "day",
        "department",
        "display_as",
        "email1",
        "email2",
        "email3",
        "end_timestamp",
        "first_name",
        "full_name",
        "identifier",
        "is_test_data",
        "job_title",
        "job_title_id",
        "job_title_ml_id",
        "last_name",
        "last_sync_timestamp",
        "main_profile_id",
        "month",
        "name_prefix",
        "name_suffix",
        "nickname",
        "notes",
        "number",
        "organization",
        "organization_profile_id",
        "original_first_name",
        "original_last_name",
        "owner_profile_id",
        "person_id",
        "phone1",
        "phone2",
        "phone3",
        "photo_file_name",
        "photo_url",
        "source",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "uploaded_timestamp",
        "visibility_id",
        "website1",
        "website2",
        "website3",
        "year"
    ),
    "contact_email_address_table": (
        "contact_email_address_id",
        "contact_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_address_id",
        "end_timestamp",
        "is_test_data",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_email_address_view": (
        "contact_email_address_id",
        "contact_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_address_id",
        "end_timestamp",
        "is_test_data",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_group_table": (
        "attribute",
        "consumer_category_id",
        "contact_group_id",
        "contact_group_type_id",
        "contact_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_circa",
        "end_date_day",
        "end_date_month",
        "end_date_year",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "identifier",
        "is_main_in_category",
        "is_potential",
        "is_recommende_by_ai",
        "is_recommended_by_contact_notes",
        "is_sure",
        "is_test_data",
        "months",
        "number",
        "participant_category_id",
        "relationship_type_id",
        "seq",
        "start_circa",
        "start_date_day",
        "start_date_month",
        "start_date_year",
        "start_timestamp",
        "supplier_category_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_group_type_ml_table": (
        "contact_group_type_id",
        "contact_group_type_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_group_type_table": (
        "contact_group_type_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_group_view": (
        "attribute",
        "consumer_category_id",
        "contact_group_id",
        "contact_group_type_id",
        "contact_id",
        "created_timestamp",
        "created_user_id",
        "end_circa",
        "end_date_day",
        "end_date_month",
        "end_date_year",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "is_main_in_category",
        "is_recommende_by_ai",
        "is_recommended_by_contact_notes",
        "is_sure",
        "is_test_data",
        "months",
        "participant_category_id",
        "relationship_type_id",
        "seq",
        "start_circa",
        "start_date_day",
        "start_date_month",
        "start_date_year",
        "start_timestamp",
        "supplier_category_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_importer_table": (
        "contact_id",
        "contact_importer_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "import_contact_id",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_importer_view": (
        "contact_id",
        "contact_importer_id",
        "import_contact_id"
    ),
    "contact_internet_domain_table": (
        "contact_id",
        "contact_internet_domain_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "internet_domain_id",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_internet_domain_view": (
        "contact_id",
        "contact_internet_domain_id",
        "internet_domain_id"
    ),
    "contact_location_table": (
        "contact_id",
        "contact_location_id",
        "contact_location_type_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "label_location_id",
        "location_id",
        "location_type_str",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_location_type_ml_table": (
        "contact_location_type_id",
        "contact_location_type_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "land_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_location_type_table": (
        "contact_location_type_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_location_view": (
        "contact_id",
        "contact_location_id",
        "location_id"
    ),
    "contact_note_contact_table_old": (
        "contact_id",
        "contact_note_contact_id",
        "contact_note_id"
    ),
    "contact_note_group_table": (
        "contact_note_group_id",
        "contact_note_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "identifier",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_note_table": (
        "block_type_id_old",
        "contact_id",
        "contact_note_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_passed_regex_old",
        "is_test_data",
        "last_parsing_timestmp_old",
        "note",
        "number",
        "seq_old",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "contact_note_text_block_table": (
        "contact_note_id",
        "contact_note_text_block_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "seq",
        "start_timestamp",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_note_text_block_view": (
        "contact_note_id",
        "contact_note_text_block_id",
        "seq",
        "text_block_id"
    ),
    "contact_note_view": (
        "block_type_id_old",
        "contact_id",
        "contact_note_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_passed_regex_old",
        "is_test_data",
        "last_parsing_timestmp_old",
        "note",
        "number",
        "seq_old",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "contact_organization_general_view": (
        "contact.first_name",
        "contact.job_title_ml.job_title_ml_id",
        "contact.job_title_ml.title",
        "contact.last_name",
        "contact_id",
        "contact_profile_id",
        "group.name",
        "group_id",
        "group_ml.title",
        "job_title_ml.title",
        "organization_ml.title",
        "organization_profile.job_title_ml.title",
        "profile.job_title_ml.job_title_ml_id",
        "profile.job_title_ml.title",
        "profile_id"
    ),
    "contact_person_table": (
        "contact_id",
        "contact_person_id",
        "contact_person_type_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "person_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_person_type_table": (
        "contact_person_type_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_person_view": (
        "contact_id",
        "contact_person_id",
        "person_id"
    ),
    "contact_phone_general_view": (
        "contact.is_test_data",
        "contact_id",
        "contact_phone_id",
        "email1",
        "first_name",
        "full_number_normalized",
        "last_name",
        "person_id",
        "phone.is_test_data",
        "phone_id"
    ),
    "contact_phone_table": (
        "contact_id",
        "contact_phone_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "phone_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_phone_view": (
        "contact_id",
        "contact_phone_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "phone_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_profile_table": (
        "contact_id",
        "contact_profile_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_potential",
        "is_test_data",
        "number",
        "profile_id",
        "relationship_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_profile_view": (
        "contact_id",
        "contact_profile_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_potential",
        "is_test_data",
        "number",
        "profile_id",
        "relationship_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_reaction_table": (
        "contact_id",
        "contact_reaction_id",
        "created_effective_contact_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "reaction_id",
        "start_timestamp",
        "updated_effective_contact_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_text_block_table": (
        "contact_id",
        "contact_text_block_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "start_timestamp",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "contact_text_block_view": (
        "contact_id",
        "contact_text_block_id",
        "is_test_data",
        "text_block_id"
    ),
    "contact_user_external_table": (
        "contact_id",
        "contact_user_external_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id"
    ),
    "contact_user_external_view": (
        "contact_id",
        "contact_user_external_id",
        "user_external_id"
    ),
    "criteria_set_general_view": (
        "child_criteria_set_id",
        "child_name",
        "coordinate",
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "end_timestamp",
        "entity_type_id",
        "entity_type_name",
        "group_id",
        "group_list_id",
        "international_code",
        "internet_domain_id",
        "internet_domain_list_id",
        "is_test_data",
        "job_group_list_id",
        "job_location_list_id",
        "job_types_id",
        "location_id",
        "location_list_id",
        "name",
        "organization_name",
        "parent_criteria_set_id",
        "parent_name",
        "profile_list_id",
        "radius",
        "radius_km",
        "radius_measure",
        "start_date_type_id",
        "start_timestamp",
        "template_condition",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "vacancy_list_id",
        "visibility_id",
        "where_sql",
        "workplace_profile_list_id"
    ),
    "criteria_set_parents_table": (
        "condition_type_id",
        "criteria_set_id",
        "criteria_set_parents_id",
        "include_exclude_type_id",
        "parent_criteria_set_id"
    ),
    "criteria_set_table": (
        "condition_type_id",
        "criteria_id",
        "criteria_set_id",
        "include_exclude_type_id",
        "name"
    ),
    "criteria_set_view": (
        "condition_type_id",
        "criteria_id",
        "criteria_set_id",
        "include_exclude_type_id",
        "name"
    ),
    "criteria_table": (
        "coordinate",
        "country_id_old",
        "county_id_old",
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "end_timestamp",
        "entity_type_id",
        "gender_list_id_old",
        "group_id",
        "group_list_id",
        "international_code",
        "internet_domain_id",
        "internet_domain_list_id",
        "is_test_data",
        "job_group_list_id",
        "job_location_list_id",
        "job_types_id",
        "label_id",
        "location_id",
        "location_list_id",
        "location_type_id",
        "max_age_old",
        "max_height_old",
        "max_kids_age_old",
        "max_number_of_kids_old",
        "min_age_old",
        "min_height_old",
        "min_kids_age_old",
        "min_number_of_kids_old",
        "name",
        "number_of_partners_old",
        "organization_name",
        "partner_experience_level_old",
        "profile_list_id",
        "radius",
        "radius_km",
        "radius_measure",
        "start_date_type_id",
        "start_timestamp",
        "template_condition",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "vacancy_list_id",
        "visibility_id",
        "where_sql",
        "workplace_profile_list_id"
    ),
    "criteria_view": (
        "coordinate",
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "end_timestamp",
        "entity_type_id",
        "group_id",
        "group_list_id",
        "international_code",
        "internet_domain_id",
        "internet_domain_list_id",
        "is_test_data",
        "job_group_list_id",
        "job_location_list_id",
        "job_types_id",
        "location_id",
        "location_list_id",
        "name",
        "organization_name",
        "profile_list_id",
        "radius",
        "radius_km",
        "radius_measure",
        "start_date_type_id",
        "start_timestamp",
        "template_condition",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "vacancy_list_id",
        "visibility_id",
        "where_sql",
        "workplace_profile_list_id"
    ),
    "criteria_profile_general_view": (
        "batch_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "criteria_id",
        "criteria_profile_id",
        "identifier",
        "is_approved",
        "is_main",
        "is_test_data",
        "number",
        "profile_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "criteria_profile_table": (
        "batch_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "criteria_id",
        "criteria_profile_id",
        "description",
        "identifier",
        "is_approved",
        "is_test_data",
        "number",
        "profile_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "criteria_profile_view": (
        "batch_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "criteria_id",
        "criteria_profile_id",
        "identifier",
        "is_approved",
        "is_test_data",
        "number",
        "profile_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "criteria_set_profile_table": (
        "batch_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "criteria_set_id",
        "criteria_set_profile_id",
        "identifier",
        "is_test_data",
        "number",
        "profile_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "criteria_set_profile_view": (
        "batch_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "criteria_set_id",
        "criteria_set_profile_id",
        "identifier",
        "is_test_data",
        "number",
        "profile_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "criteria_promotional_message_to_person_table": (
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "criteria_promotional_message_to_person_id",
        "end_timestamp",
        "multiply_from_yesterday",
        "promotional_message_to_person_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "data_source_category_ml_table": (
        "created_timestamp",
        "created_user_id",
        "data_source_category_id",
        "data_source_category_ml_id",
        "data_source_name",
        "data_source_name_approved",
        "end_timestamp",
        "lang_code",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "data_source_category_table": (
        "data_source_category_id",
        "name"
    ),
    "data_source_service_table_old": (
        "data_source_service_id",
        "name"
    ),
    "data_source_type_general_view": (
        "created_timestamp",
        "created_user_id",
        "data_source_category_id",
        "data_source_type_id",
        "data_source_type_ml.title",
        "end_timestamp",
        "is_test_data",
        "name",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "data_source_type_ml_en_view": (
        "data_source_type_id",
        "name",
        "subsystem_id",
        "subsystem_ml.title",
        "system_id",
        "system_ml.tite",
        "title"
    ),
    "data_source_type_ml_table": (
        "created_timestamp",
        "created_user_id",
        "data_source_type_id",
        "data_source_type_ml_id",
        "end_timestamp",
        "is_test_data",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "data_source_type_table": (
        "created_timestamp",
        "created_user_id",
        "data_source_category_id",
        "data_source_type_id",
        "end_timestamp",
        "is_test_data",
        "name",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "data_source_external_user_ml_table": (
        "created_timestamp",
        "created_user_id",
        "data_source_id",
        "data_source_name",
        "data_source_name_approved",
        "data_source_type_ml_id",
        "end_timestamp",
        "lang_code",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "data_source_external_user_table": (
        "created_timestamp",
        "created_user_id",
        "data_source_external_user_id",
        "data_source_id",
        "end_timestamp",
        "is_test_data",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id"
    ),
    "data_source_field_general_view": (
        "data_source_field_id",
        "data_source_type_id",
        "external_field_name",
        "field_id",
        "name",
        "position"
    ),
    "data_source_field_table": (
        "data_source_field_id",
        "data_source_type_id",
        "external_field_name",
        "field_id",
        "position"
    ),
    "data_source_field_view": (
        "data_source_field_id",
        "data_source_type_id",
        "external_field_name",
        "field_id",
        "position"
    ),
    "data_source_instance_general_view": (
        "computer_name",
        "created_timestamp",
        "data_source_instance_id",
        "data_source_type_id",
        "end_index",
        "end_timestamp",
        "file_or_api",
        "filename",
        "import_or_last_sync_timestamp",
        "imported_file_created_timestamp",
        "is_test_data",
        "name",
        "path",
        "start_index",
        "start_timestamp",
        "user_external_id"
    ),
    "data_source_instance_table": (
        "computer_name",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "data_source_instance_id",
        "data_source_type_id",
        "end_index",
        "end_timestamp",
        "file_or_api",
        "filename",
        "identifier",
        "import_or_last_sync_timestamp",
        "imported_file_created_timestamp",
        "is_test_data",
        "name",
        "number",
        "path",
        "start_index",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "visibility_id"
    ),
    "data_source_instance_view": (
        "computer_name",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "data_source_instance_id",
        "data_source_type_id",
        "end_index",
        "end_timestamp",
        "file_or_api",
        "filename",
        "identifier",
        "import_or_last_sync_timestamp",
        "imported_file_created_timestamp",
        "is_test_data",
        "name",
        "number",
        "path",
        "start_index",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "visibility_id"
    ),
    "age_media": (
        "age",
        "filename",
        "id",
        "media"
    ),
    "planned_database_schema_change_table": (
        "change",
        "database_version",
        "new_field_name",
        "new_object",
        "old_field_name",
        "old_object",
        "planned_database_schema_change_",
        "schema",
        "team_members_involved"
    ),
    "table_definition_general_view": (
        "schema_main",
        "schema_mapping",
        "table_defintion_id_main",
        "table_defintion_id_mapping",
        "table_name_main",
        "table_name_mapping"
    ),
    "table_definition_table": (
        "contact_mapping_table_id",
        "description",
        "end_timestamp",
        "entity_type_id1",
        "entity_type_id2",
        "insert_is_undelete",
        "is_created_updated_fields",
        "is_dynamic",
        "is_entity",
        "is_graph",
        "is_history",
        "is_logical_delete_fields",
        "is_main_column",
        "is_mapping_table",
        "is_metadata",
        "is_metadata_whole_table",
        "is_metrics",
        "is_ml_child_table",
        "is_ml_parent_table",
        "is_number_column",
        "is_one_table_per_all_tenants",
        "is_pii",
        "is_sensative",
        "is_single_and_multi_value",
        "is_test_data_column",
        "is_tree",
        "is_user_data",
        "is_user_data_whole_table",
        "is_visibility",
        "name_of_single_value_column",
        "profile_mapping_table_id",
        "schema",
        "sensative_columns",
        "seq",
        "table_definition_id",
        "table_list_id",
        "table_name",
        "table_type",
        "view_name"
    ),
    "table_definition_view": (
        "contact_mapping_table_id",
        "entity_type_id1",
        "entity_type_id2",
        "is_created_updated_fields",
        "is_entity",
        "is_graph",
        "is_history",
        "is_logical_delete_fields",
        "is_main_column",
        "is_mapping_table",
        "is_metrics",
        "is_ml_child_table",
        "is_ml_parent_table",
        "is_number_column",
        "is_one_table_per_all_tenants",
        "is_pii",
        "is_sensative",
        "is_single_and_multi_value",
        "is_test_data_column",
        "is_tree",
        "is_visibility",
        "name_of_single_value_column",
        "profile_mapping_table_id",
        "schema",
        "sensative_columns",
        "seq",
        "table_definition_id",
        "table_list_id",
        "table_name",
        "table_type",
        "view_name"
    ),
    "table_deployment": (
        "environment_id",
        "id",
        "schema",
        "table_id",
        "table_name",
        "version"
    ),
    "table_deployments": (
        "environment_id",
        "id",
        "table_id",
        "timestamp",
        "version"
    ),
    "table_history_table": (
        "datetime",
        "is_successful",
        "MAX_EXECUTION_TIME Miliseconds",
        "MySQL Workbench Duration Seconds",
        "MySQL Workbench Seconds",
        "rows",
        "schema",
        "sql_statement",
        "table",
        "table_history_id"
    ),
    "table_list_member": (
        "id",
        "table_id",
        "table_list_id"
    ),
    "table_list_old": (
        "table_id"
    ),
    "table_old": (
        "entity_id",
        "id",
        "schema",
        "table_name"
    ),
    "table_type_table": (
        "description",
        "name",
        "table_type_id"
    ),
    "device_profile_table": (
        "created_timestamp",
        "created_user_id",
        "device_id",
        "device_profile_id",
        "end_timestamp",
        "profile_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "dialog_workflow_action_en_general_view": (
        "description",
        "lang_code",
        "name",
        "title",
        "workflow_action_id"
    ),
    "dialog_workflow_general_view": (
        "description",
        "dialog_workflow_script_id",
        "dialog_workflow_script_ml_id",
        "dialog_workflow_state_id",
        "start_state_id",
        "state_id",
        "title",
        "variable name",
        "variable1_id",
        "workflow action name",
        "workflow_action_id"
    ),
    "dialog_workflow_script_ml_table": (
        "dialog_workflow_script_id",
        "dialog_workflow_script_ml_id",
        "lang_code",
        "title"
    ),
    "dialog_workflow_script_ml_view": (
        "dialog_workflow_script_id",
        "dialog_workflow_script_ml_id",
        "lang_code",
        "title"
    ),
    "dialog_workflow_script_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "dialog_workflow_script_id",
        "dialog_workflow_script_status_text",
        "end_timestamp",
        "is_test_data",
        "max_state_id",
        "min_state_id",
        "name",
        "start_state_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "dialog_workflow_script_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "dialog_workflow_script_id",
        "end_timestamp",
        "is_test_data",
        "max_state_id",
        "name",
        "start_state_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "dialog_workflow_state_history_table_old": (
        "id",
        "profile_id",
        "state_id",
        "timestamp",
        "variable_id",
        "variable_value"
    ),
    "dialog_workflow_state_history_view_old": (
        "profile_id",
        "state_id",
        "timestamp",
        "variable_id",
        "variable_value_new"
    ),
    "dialog_workflow_state_ml_table": (
        "dialog_workflow_state_id",
        "dialog_workflow_state_ml_id",
        "lang_code",
        "title"
    ),
    "dialog_workflow_state_table": (
        "channel_id",
        "checked_in",
        "criteria_id",
        "criteria_set_id",
        "dialog_workflow_state_id",
        "end_timestamp",
        "lang_code",
        "message_template_id",
        "name",
        "next_state_id",
        "next_state_id_if_there_is_no_feedback",
        "no_feedback_milliseconds",
        "parameter1",
        "parent_state_id",
        "remark",
        "result_figure_max",
        "result_figure_min",
        "result_logical",
        "state_id",
        "variable1_id",
        "variable2_id",
        "version",
        "workflow_action_id"
    ),
    "dialog_workflow_state_view": (
        "dialog_workflow_state_id",
        "lang_code",
        "message_template_id",
        "next_state_id",
        "next_state_id_if_there_is_no_feedback",
        "no_feedback_milliseconds",
        "parameter1",
        "parent_state_id",
        "result_figure_max",
        "result_figure_min",
        "result_logical",
        "state_id",
        "variable1_id",
        "workflow_action_id"
    ),
    "workflow_action_ml_table": (
        "lang_code",
        "title",
        "workflow_action_id",
        "workflow_action_ml_id"
    ),
    "workflow_action_ml_view": (
        "lang_code",
        "title",
        "workflow_action_id",
        "workflow_action_ml_id"
    ),
    "workflow_action_table": (
        "description",
        "name",
        "software_development_status",
        "workflow_action_id"
    ),
    "workflow_state_old": (
        "id",
        "profile_id",
        "state_id",
        "timestamp"
    ),
    "email_address_ml_table": (
        "email_address_id",
        "email_address_ml_id",
        "is_test_data",
        "lang_code",
        "title",
        "title_approved"
    ),
    "email_address_ml_view": (
        "email_address_id",
        "email_address_ml_id",
        "is_test_data",
        "lang_code",
        "title",
        "title_approved"
    ),
    "email_address_review_view": (
        "email_address",
        "email_address_approved",
        "email_address_id",
        "is_test_data"
    ),
    "email_address_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_address",
        "email_address_approved",
        "email_address_id",
        "end_timestamp",
        "identifier",
        "internet_domain_id",
        "is_shared_email_address",
        "is_system_data",
        "is_test_data",
        "is_verified",
        "name",
        "number",
        "profile_id_old",
        "start_timestamp",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "username",
        "verification_expiration",
        "verification_pin",
        "visibility_id"
    ),
    "email_address_view": (
        "created_timestamp",
        "created_user_id",
        "email_address",
        "email_address_approved",
        "email_address_id",
        "end_timestamp",
        "is_test_data",
        "is_verified",
        "number",
        "profile_id_old",
        "start_timestamp",
        "text_block_id",
        "updated_timestamp",
        "updated_user_id",
        "verification_expiration",
        "verification_pin"
    ),
    "email_address_profile_general_view": (
        "contact_email_address_id",
        "contact_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_address_id",
        "email_address_of_contact",
        "email_address_of_person",
        "email_address_of_profile",
        "email_address_person_id",
        "email_address_profile_id",
        "end_timestamp",
        "is_main",
        "is_sure",
        "person_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "email_address_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_address_id",
        "email_address_profile_id",
        "end_timestamp",
        "is_main",
        "is_sure",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "email_address_profile_verification_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_address_profile_id",
        "email_address_profile_verification_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "email_address_profile_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_address_id",
        "email_address_profile_id",
        "end_timestamp",
        "is_main",
        "is_sure",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "entity_type_ml_en_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "entity_type_id",
        "entity_type_name",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "entity_type_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "entity_type_id",
        "entity_type_ml_id",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "entity_type_ml_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "entity_type_id",
        "entity_type_ml_id",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "entity_type_table": (
        "created_timestamp",
        "created_user_id",
        "criteria_schema_name",
        "criteria_table_name",
        "criteria_view_name",
        "end_timestamp",
        "entity_type_id",
        "is_item_type",
        "is_test_data",
        "name",
        "schema_name",
        "start_timestamp",
        "system_id",
        "table_name",
        "updated_timestamp",
        "updated_user_id",
        "view_name",
        "view_with_deleted_and_test_data"
    ),
    "entity_type_view": (
        "created_timestamp",
        "created_user_id",
        "criteria_schema_name",
        "criteria_table_name",
        "criteria_view_name",
        "end_timestamp",
        "entity_type_id",
        "is_item_type",
        "is_test_data",
        "name",
        "schema_name",
        "start_timestamp",
        "system_id",
        "table_name",
        "updated_timestamp",
        "updated_user_id",
        "view_name",
        "view_with_deleted_and_test_data"
    ),
    "event_hashag_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "event_hashag_id",
        "event_id",
        "hashtag"
    ),
    "event_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_id",
        "event_ml_id",
        "identifier",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "event_ml_view": (
        "event_id",
        "lang_code",
        "title"
    ),
    "event_participant_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_id",
        "event_participant_id",
        "participant_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "event_potential_view": (
        "coordinate",
        "created_user_id",
        "entity_id",
        "entity_type_id",
        "lang_code",
        "location_id",
        "title",
        "updated_timestamp",
        "visibility_id"
    ),
    "event_price_ml_table": (
        "created_timestamp",
        "created_user_id",
        "description",
        "description_approved",
        "event_price_id",
        "event_price_ml_id",
        "lang_code",
        "updated_timestamp",
        "updated_user_id"
    ),
    "event_price_table": (
        "created_timestamp",
        "created_user_id",
        "currency",
        "event_id",
        "event_price_id",
        "price",
        "price_usd",
        "updated_timestamp",
        "updated_user_id"
    ),
    "event_profile_email_table": (
        "channel_id",
        "event_id",
        "event_profile_email_id",
        "is_list_with_full_names",
        "is_number_of_participants",
        "number_of_hours_before_event",
        "profile_id"
    ),
    "event_status_ml_table": (
        "created_timestamp",
        "created_user_id",
        "event_status_id",
        "event_status_ml_id",
        "lang_code",
        "title",
        "title_approved",
        "updated_timestamp",
        "updated_user_id"
    ),
    "event_status_table": (
        "event_status_id"
    ),
    "event_table": (
        "access_start_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_approved",
        "event_id",
        "facebook_event_url",
        "genre",
        "identifier",
        "is_family",
        "is_need_confirmation",
        "is_need_registration",
        "is_test_data",
        "location_id",
        "meetup_event_url",
        "number",
        "organizers_profile_id",
        "parent_event_id",
        "registration_url",
        "segement",
        "start_timestamp",
        "sub_genre",
        "sub_type",
        "timezone",
        "type",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id",
        "website_url"
    ),
    "event_view": (
        "access_start_timestamp",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_approved",
        "event_id",
        "facebook_event_url",
        "genre",
        "is_family",
        "is_need_confirmation",
        "is_need_registration",
        "is_test_data",
        "location_id",
        "meetup_event_url",
        "number",
        "organizers_profile_id",
        "parent_event_id",
        "registration_url",
        "segement",
        "start_timestamp",
        "sub_genre",
        "sub_type",
        "timezone",
        "type",
        "updated_timestamp",
        "updated_user_id",
        "website_url"
    ),
    "participant_table": (
        "number_of_participants",
        "paied",
        "participant_id",
        "price",
        "profile_id"
    ),
    "event_external_approved_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "environment_id",
        "event_external_id",
        "external_event_identifier",
        "is_approved",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "updated_timestamp",
        "updated_user_id",
        "url"
    ),
    "event_external_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "environment_id",
        "event_external_id",
        "external_event_identifier",
        "is_approved",
        "is_test_data",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "updated_timestamp",
        "updated_user_id",
        "url"
    ),
    "event_external_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "environment_id",
        "event_external_id",
        "external_event_identifier",
        "is_approved",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "updated_timestamp",
        "updated_user_id",
        "url"
    ),
    "event_group_table": (
        "event_group_id",
        "event_id",
        "group_id"
    ),
    "event_group_view": (
        "event_group_id",
        "event_id",
        "group_id"
    ),
    "event_location_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_id",
        "event_location_id",
        "identifier",
        "is_test_data",
        "location_id",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "event_location_view": (
        "event_id",
        "event_location_id",
        "location_id"
    ),
    "event_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_id",
        "event_price_id",
        "event_profile_id",
        "event_profile_type",
        "identifier",
        "is_approved",
        "is_arrived",
        "is_invited",
        "is_not_interested",
        "is_tentative",
        "is_test_data",
        "number",
        "profile_id",
        "rank",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "event_profile_type_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "event_profile_type_id",
        "event_profile_type_ml_id",
        "identifier",
        "is_main_title",
        "is_test_data",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "event_profile_type_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_profile_type_id",
        "group_type_id",
        "identifier",
        "is_hierarchy",
        "is_location",
        "is_organization",
        "is_prioritze",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "field_alias_table": (
        "field_alias_id",
        "field_id",
        "field_name",
        "subsystem_id",
        "system_id",
        "visibility_id"
    ),
    "field_alias_view": (
        "field_alias_id",
        "field_id",
        "field_name",
        "subsystem_id",
        "system_id",
        "visibility_id"
    ),
    "field_general_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "database_field_name",
        "database_sub_field_name",
        "database_sub_field_value",
        "description",
        "end_timestamp",
        "field_id",
        "identifier",
        "internal_description",
        "is_ml_table",
        "is_test_data",
        "name",
        "number",
        "processing_database_field_name",
        "processing_id",
        "start_timestamp",
        "table_id",
        "table_name",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "variable.name",
        "variable_id",
        "visibility_id"
    ),
    "field_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "database_field_name",
        "database_sub_field_name",
        "database_sub_field_value",
        "description",
        "end_timestamp",
        "field_id",
        "identifier",
        "internal_description",
        "is_ml_table",
        "is_test_data",
        "name",
        "number",
        "processing_database_field_name",
        "processing_id",
        "start_timestamp",
        "table_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "variable_id",
        "visibility_id"
    ),
    "field_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "database_field_name",
        "database_sub_field_name",
        "database_sub_field_value",
        "description",
        "end_timestamp",
        "field_id",
        "identifier",
        "internal_description",
        "is_ml_table",
        "is_test_data",
        "name",
        "number",
        "processing_database_field_name",
        "processing_id",
        "start_timestamp",
        "table_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "variable_id",
        "visibility_id"
    ),
    "variable_ml_table": (
        "lang_code",
        "title",
        "variable_id",
        "variable_ml_id",
        "visibility_id"
    ),
    "variable_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "field_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "person_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "variable_id",
        "visibility_id"
    ),
    "variable_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "field_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "person_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "variable_id",
        "visibility_id"
    ),
    "field_profile_text_block_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "field_id",
        "field_profile_text_block_id",
        "identifier",
        "is_test_data",
        "number",
        "profile_id",
        "start_timestamp",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "field_text_block_type_table": (
        "comment",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "field_id",
        "field_text_block_type_id",
        "index_in_regex",
        "is_multiple",
        "lang_code",
        "regex",
        "start_timestamp",
        "text_block_type_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "field_text_block_type_view": (
        "comment",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "field_id",
        "field_text_block_type_id",
        "index_in_regex",
        "is_multiple",
        "lang_code",
        "regex",
        "start_timestamp",
        "text_block_type_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "form_message_template_table": (
        "criteria_set_id",
        "form_id",
        "form_message_template_id",
        "max_message_template",
        "message_template_id",
        "min_message_template",
        "page",
        "seq"
    ),
    "form_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "form_id",
        "form_type_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "form_type_table": (
        "channel_type_id",
        "form_type_table_id",
        "name",
        "version"
    ),
    "form_transaction_table": (
        "action_id",
        "actual_channel_id",
        "actual_sent_timestamp",
        "bcc_email",
        "bcc_profile_id",
        "bcc_profile_list_id",
        "body",
        "campaign_id",
        "cc_email",
        "cc_profile_id",
        "cc_profile_list_id",
        "class_parameters_json",
        "compound_form",
        "compound_form_json",
        "compound_form_json_version",
        "created_timestamp",
        "created_user_id",
        "email_form_id",
        "end_timestamp",
        "form_id",
        "form_transaction_id",
        "form_type_id",
        "function_parameters_json",
        "group_id",
        "group_list_id",
        "is_gen_ai",
        "is_moderator_approved",
        "is_require_moderator",
        "is_test_data",
        "location_id",
        "machine_learning_model_id",
        "mailbox_id",
        "message_channel_id",
        "message_status_id",
        "moderator_feedback_text",
        "moderator_feedback_type",
        "moderator_profile_id",
        "number",
        "occurrence_id",
        "pin",
        "previous_form_id",
        "process_id",
        "profile_id",
        "provider_id",
        "push_notification",
        "queue_status_id",
        "request_to_send_timestamp",
        "requested_channel_id",
        "return_code",
        "return_form",
        "returned_value",
        "scheduled_sent_timestamp",
        "sender_email",
        "sender_profile_id",
        "server_ip_v4",
        "server_ip_v6",
        "session",
        "session_id",
        "start_timestamp",
        "stderr",
        "stdout",
        "subject",
        "thread_id",
        "to_email",
        "to_profile_id",
        "to_profile_list_id",
        "updated_timestamp",
        "updated_user_id",
        "user_jwt",
        "visibility_id"
    ),
    "gender_list_member_table": (
        "gender_id",
        "gender_list_id",
        "gender_list_member_id"
    ),
    "gender_list_member_view": (
        "gender_id",
        "gender_list_id",
        "gender_list_member_id",
        "gender_list_name",
        "gender_name",
        "gender_title"
    ),
    "gender_list_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "gender_list_id",
        "gender_list_id2",
        "name",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "gender_ml_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "gender_id",
        "gender_ml_id",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "gender_ml_view": (
        "gender_id",
        "lang_code",
        "title"
    ),
    "gender_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "gender_id",
        "is_test_data",
        "name",
        "start_timestamp",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "age_group_group_table": (
        "age_group_group_id",
        "age_group_id",
        "group_id",
        "sequence"
    ),
    "age_group_table": (
        "age_group_id",
        "max_age",
        "min_age"
    ),
    "group_approved_view": (
        "coordinate",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_category_id",
        "group_id",
        "is_approved",
        "is_interest",
        "is_job_title",
        "location_id",
        "location_list_id",
        "members_visibility_id",
        "non_members_visibility_id",
        "parent_group_id",
        "parent_group_list_id",
        "sequence",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_category_ml_table": (
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "group_category_id",
        "group_category_ml_id",
        "is_main_title",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_category_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_category_id",
        "group_type_id",
        "is_hierarchy",
        "is_location",
        "is_organization",
        "is_prioritze",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_en_approved_main_title_view": (
        "group_id",
        "is_interest",
        "parent_group_id",
        "seq",
        "title"
    ),
    "group_group_type_table": (
        "group_group_type_id",
        "group_id",
        "group_type_id"
    ),
    "group_group_type_view": (
        "group_group_type_id",
        "group_id",
        "group_type_id"
    ),
    "group_list_member_table": (
        "group_id",
        "group_list_id",
        "group_list_member_id"
    ),
    "group_list_member_view": (
        "group_id",
        "group_list_id",
        "group_list_member_id"
    ),
    "group_list_table": (
        "created_timestamp",
        "created_user_id",
        "group_list_id",
        "is_and",
        "name",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_list_view": (
        "created_timestamp",
        "created_user_id",
        "group_list_id",
        "is_and",
        "name",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_ml_also_not_approved_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "identifier",
        "is_main_title",
        "is_test_data",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_ml_approved_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "identifier",
        "is_main_title",
        "is_test_data",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_ml_en_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "identifier",
        "is_main_title",
        "is_test_data",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "group_ml_not_approved_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "identifier",
        "is_main_title",
        "is_test_data",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "identifier",
        "is_description_approved",
        "is_main_title",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "group_ml_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "group_ml_id",
        "identifier",
        "is_interest",
        "is_main_title",
        "is_test_data",
        "lang_code",
        "number",
        "parent_group_id",
        "sequence",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_potential_view": (
        "coordinate",
        "created_user_id",
        "entity_id",
        "entity_type_id",
        "lang_code",
        "location_id",
        "title",
        "updated_timestamp",
        "visibility_id"
    ),
    "group_table": (
        "coordinate",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_profile_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_id",
        "group_category_id",
        "group_id",
        "hashtag",
        "identifier",
        "is_activity",
        "is_approved",
        "is_building",
        "is_campaign",
        "is_city",
        "is_continent",
        "is_country",
        "is_county",
        "is_event",
        "is_first_name",
        "is_geo",
        "is_interest",
        "is_job_title",
        "is_language",
        "is_last_name",
        "is_marital_status",
        "is_neighbourhood",
        "is_official",
        "is_organization",
        "is_reddit_group",
        "is_region",
        "is_relationship",
        "is_religion",
        "is_role",
        "is_skill",
        "is_sport",
        "is_state",
        "is_street",
        "is_test_data",
        "is_zip_code",
        "location_id",
        "location_list_id",
        "main_group_type_id",
        "members_visibility_id",
        "name",
        "non_members_visibility_id",
        "number",
        "parent_group_id",
        "parent_group_list_id",
        "profile_id",
        "profile_list_id",
        "sequence",
        "start_timestamp",
        "system_group_name",
        "system_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "group_type_ml_table": (
        "group_type_id",
        "group_type_ml_id",
        "lang_code",
        "title"
    ),
    "group_type_ml_view": (
        "group_type_id",
        "group_type_ml_id",
        "lang_code",
        "name",
        "title"
    ),
    "group_type_table": (
        "examples_old",
        "group_type_id",
        "is_contact_classification",
        "is_gender",
        "is_job_title",
        "is_location",
        "is_organization",
        "is_organization_classification",
        "name"
    ),
    "group_view": (
        "coordinate",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_profile_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "event_id",
        "group_category_id",
        "group_id",
        "hashtag",
        "identifier",
        "is_approved",
        "is_building",
        "is_city",
        "is_continent",
        "is_country",
        "is_county",
        "is_event",
        "is_first_name",
        "is_geo",
        "is_interest",
        "is_job_title",
        "is_last_name",
        "is_neighbourhood",
        "is_official",
        "is_organization",
        "is_region",
        "is_state",
        "is_street",
        "is_test_data",
        "is_zip_code",
        "location_id",
        "location_list_id",
        "main_group_type_id",
        "members_visibility_id",
        "name",
        "non_members_visibility_id",
        "number",
        "parent_group_id",
        "parent_group_list_id",
        "profile_id",
        "sequence",
        "start_timestamp",
        "system_group_name",
        "system_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_location_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "group_location_id",
        "group_location_type_id",
        "identifier",
        "is_test_data",
        "label_location_id",
        "location_id",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_location_type_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_location_type_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_profile_general_view": (
        "consumer_category_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_circa",
        "end_date_day",
        "end_date_month",
        "end_date_year",
        "end_timestamp",
        "group.name",
        "group_id",
        "group_profile_id",
        "group_profile_type_id",
        "identifier",
        "is_approved_by_group_admin",
        "is_recommended",
        "is_request_by_the_user",
        "is_sure",
        "is_test_data",
        "months",
        "number",
        "participant_category_id",
        "profile.name",
        "profile_id",
        "rank",
        "relationship_type_id",
        "start_circa",
        "start_date_day",
        "start_date_month",
        "start_date_year",
        "start_timestamp",
        "supplier_category_id",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_profile_table": (
        "consumer_category_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_circa",
        "end_date_day",
        "end_date_month",
        "end_date_year",
        "end_timestamp",
        "group_id",
        "group_profile_id",
        "group_profile_type_id",
        "identifier",
        "is_admin",
        "is_approved_by_group_admin",
        "is_moderator",
        "is_recommended",
        "is_request_by_the_user",
        "is_sure",
        "is_test_data",
        "months",
        "number",
        "participant_category_id",
        "profile_id",
        "rank",
        "relationship_type_id",
        "start_circa",
        "start_date_day",
        "start_date_month",
        "start_date_year",
        "start_timestamp",
        "supplier_category_id",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_profile_type_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_profile_type_id",
        "group_profile_type_ml_id",
        "identifier",
        "is_test_data",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "group_profile_type_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_profile_type_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "group_profile_view": (
        "consumer_category_id",
        "created_timestamp",
        "created_user_id",
        "end_circa",
        "end_date_day",
        "end_date_year",
        "end_timestamp",
        "group_id",
        "group_profile_id",
        "group_profile_type_id",
        "is_test_data",
        "participant_category_id",
        "profile_id",
        "relationship_type_id",
        "start_circa",
        "start_date_day",
        "start_date_month",
        "start_date_year",
        "start_timestamp",
        "supplier_category_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "identifier_group_by_entity_type_view": (
        "entity_type_ml.title",
        "Number of Entries"
    ),
    "identifier_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "entity_type_id",
        "identifier",
        "identifier_id",
        "is_test_data",
        "number",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp"
    ),
    "identifier_view": (
        "entity_type_id",
        "identifier",
        "identifier_id",
        "is_test_data",
        "number"
    ),
    "import_contact_table_old": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "facebook_profile_name",
        "facebook_profile_number",
        "google_account",
        "identifier",
        "import_contact_id",
        "importer_table_id",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "business_profile_view": (
        "contact_id",
        "Country",
        "data_imported_json",
        "data_source.title",
        "department",
        "email1",
        "entity_type_id",
        "entity_type_ml.title",
        "full_name",
        "job_title",
        "name_prefix",
        "notes",
        "organization",
        "phone1"
    ),
    "importer_contact_google_people_api_sync_view": (
        "contact_id",
        "last_sync_time"
    ),
    "importer_entity_types_imported_group_by_date_source_view": (
        "created_user_id",
        "Data Source Title",
        "data_source_type_id",
        "date",
        "entity_type_id",
        "entity_type_title",
        "first_name",
        "last_name",
        "main_email",
        "Number of Entries",
        "username"
    ),
    "importer_entity_types_imported_group_by_source_view": (
        "Data Source Title",
        "Entity Type Title",
        "Number of Entries"
    ),
    "importer_general_view": (
        "country_ml.title",
        "created_timestamp",
        "created_user_id",
        "data_source_instance_id",
        "data_source_instance_name",
        "data_source_type_id",
        "data_source_type_id_old",
        "data_source_type_ml.title",
        "end_timestamp",
        "entity_id",
        "entity_type_id",
        "handle",
        "importer.is_test_data",
        "importer_id",
        "is_test_data",
        "location_id",
        "profile_id",
        "start_timestamp",
        "system_ml.title",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "user_external.system_id",
        "user_external_country_id_old",
        "user_external_id",
        "username"
    ),
    "importer_per_entity_type_view": (
        "count(importer.importer_table.entity_type_id)",
        "created_timestamp",
        "entity_type_id",
        "entity_type_ml.title"
    ),
    "importer_recent_view": (
        "created_timestamp",
        "data_source_type.title",
        "entity_id",
        "entity_type_id",
        "entity_type_ml.title",
        "importer_country_name",
        "importer_id"
    ),
    "importer_table": (
        "created_timestamp",
        "created_user_id",
        "data_imported_json",
        "data_source_external_user_id_old",
        "data_source_instance_id",
        "data_source_type_id_old",
        "end_timestamp",
        "entity_id",
        "entity_type_id",
        "google_calendar_id",
        "google_people_api_resource_name",
        "importer_id",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "user_external_country_id_old",
        "user_external_id"
    ),
    "importer_vacancy_view": (
        "Country",
        "created_timestamp",
        "data_source_type.title",
        "entity_type_id",
        "title",
        "vacancy_name"
    ),
    "importer_view": (
        "created_timestamp",
        "created_user_id",
        "data_imported_json",
        "data_source_external_user_id_old",
        "data_source_instance_id",
        "data_source_type_id_old",
        "end_timestamp",
        "entity_id",
        "entity_type_id",
        "google_calendar_id",
        "google_people_api_resource_name",
        "importer_id",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "user_external_country_id_old",
        "user_external_id"
    ),
    "internet_domain_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "domain",
        "end_timestamp",
        "identifier",
        "internet_domain_id",
        "is_commercial_webmail",
        "is_email_assign_profile_organization_to_people",
        "is_test_data",
        "is_url_assign_profile_organization_to_people",
        "number",
        "profile_id",
        "profile_list_id",
        "start_timestamp",
        "top_level_domain",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "internet_domain_view": (
        "domain",
        "internet_domain_id",
        "is_commercial_webmail",
        "is_email_assign_profile_organization_to_people",
        "is_url_assign_profile_organization_to_people",
        "profile_id",
        "profile_list_id",
        "top_level_domain"
    ),
    "item_profile_general_view": (
        "item_id",
        "item_type_id",
        "profile_id",
        "recommendation_model_id",
        "source_name"
    ),
    "item_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "exposure_time_miliseconds",
        "identifier",
        "is_test_data",
        "item_id",
        "item_profile_id",
        "item_type_id",
        "message_id",
        "number",
        "profile_id",
        "recommendation_model_id",
        "seen_body_end_timestamp",
        "seen_body_start_timestamp",
        "seen_summary_end_timestamp",
        "seen_summary_start_timestamp",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "item_profile_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "exposure_time_miliseconds",
        "is_test_data",
        "item_id",
        "item_profile_id",
        "message_id",
        "profile_id",
        "seen_body_end_timestamp",
        "seen_body_start_timestamp",
        "seen_summary_end_timestamp",
        "seen_summary_start_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "job_title_profile_table": (
        "end_timestamp",
        "job_title_id",
        "job_title_ml_id",
        "job_title_profile_id",
        "profile_id"
    ),
    "job_title_profile_view": (
        "end_timestamp",
        "job_title_id",
        "job_title_ml_id",
        "job_title_profile_id",
        "profile_id"
    ),
    "json_version_source_code_table": (
        "json_version_id",
        "json_version_source_code_id",
        "source_code_id"
    ),
    "json_version_table": (
        "field_name",
        "json_name",
        "json_version_id",
        "table_id",
        "version"
    ),
    "email_address_label_view": (
        "email_address_id",
        "email_address_label_id",
        "label_id"
    ),
    "label_email_table_old": (
        "created_timestamp",
        "created_user_id",
        "id",
        "label_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_list_member_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "label_id",
        "label_list_id",
        "label_list_member_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_list_member_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "label_id",
        "label_list_id",
        "label_list_member_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_list_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "label_list_id",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "label_list_id",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "label_id",
        "label_ml_id",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_profile_table_old": (
        "created_timestamp",
        "created_user_id",
        "id",
        "label_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_question_table": (
        "created_timestamp",
        "created_user_id",
        "id",
        "label_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_approved",
        "is_test_data",
        "label_id",
        "location_id",
        "name",
        "name_approved",
        "number",
        "parent_label_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_message_table": (
        "label_id",
        "label_message_id",
        "message_id"
    ),
    "label_message_view": (
        "label_id",
        "label_message_id",
        "message_id"
    ),
    "label_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_system",
        "is_test_data",
        "label_id",
        "label_profile_id",
        "number",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "label_profile_view": (
        "label_id",
        "label_profile_id",
        "profile_id"
    ),
    "city_list_member_table": (
        "city_id",
        "city_list_id",
        "city_list_member_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "city_list_member_view": (
        "city_id",
        "city_list_id",
        "city_list_member_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "city_list_table": (
        "city_list_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "city_ml_table": (
        "city_id",
        "city_ml_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "city_ml_view": (
        "city_id",
        "coordinate",
        "created_timestamp",
        "created_user_id",
        "is_main",
        "lang_code",
        "location_city_name",
        "name",
        "phonecode",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "city_table": (
        "city_id",
        "coordinate",
        "country_id",
        "country_id_old",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "is_test_data",
        "name",
        "new_city_id",
        "number",
        "phonecode",
        "state_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "country_general_view": (
        "coordinate",
        "country_id",
        "created_timestamp",
        "created_user_id",
        "group.name",
        "group.title",
        "group_id",
        "identifier",
        "is_test_data",
        "iso",
        "iso3",
        "name",
        "nicename",
        "numcode",
        "phonecode",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "country_list_member_table": (
        "country_id",
        "country_list_id",
        "country_list_member_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "country_list_member_view": (
        "country_id",
        "country_list_id",
        "country_list_member_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "country_list_table": (
        "country_list_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "country_ml_table": (
        "country_id",
        "country_id_old",
        "country_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "country_ml_view": (
        "coordinate",
        "country_id",
        "is_title_approved",
        "iso",
        "iso3",
        "lang_code",
        "name",
        "nicename",
        "numcode",
        "phonecode",
        "title"
    ),
    "country_table": (
        "coordinate",
        "country_id",
        "created_timestamp",
        "created_user_id",
        "group_id",
        "identifier",
        "is_test_data",
        "iso",
        "iso3",
        "name",
        "nicename",
        "numcode",
        "phonecode",
        "updated_timestamp",
        "updated_user_id"
    ),
    "country_view": (
        "coordinate",
        "country_id",
        "created_timestamp",
        "created_user_id",
        "group_id",
        "identifier",
        "is_test_data",
        "iso",
        "iso3",
        "name",
        "nicename",
        "numcode",
        "phonecode",
        "updated_timestamp",
        "updated_user_id"
    ),
    "county_list_member_table": (
        "county_id",
        "county_list_id",
        "county_list_member_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "county_list_member_view": (
        "county_id",
        "county_list_id",
        "county_list_member_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "county_list_table": (
        "county_list_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "county_ml_general_view": (
        "county_id",
        "county_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "county_ml_table": (
        "county_id",
        "county_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "county_ml_view": (
        "coordinate",
        "county_id",
        "is_title_approved",
        "lang_code",
        "state_id",
        "title"
    ),
    "county_ml_with_deleted_and_test_data_view": (
        "county_id",
        "county_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "state_id",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "county_table": (
        "coordinate",
        "country_id",
        "county_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "is_test_data",
        "name",
        "number",
        "state_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_criteria_table": (
        "city_id",
        "city_list_id",
        "country_id",
        "county_id",
        "criteria_id",
        "location_id",
        "location_list_id",
        "location_type_id",
        "neighbourhood_id",
        "state_id",
        "street_id"
    ),
    "location_field_ml_table": (
        "field_name",
        "is_test_data",
        "lang_code",
        "location_id",
        "locaton_field_ml_id",
        "prime",
        "title",
        "title_approved"
    ),
    "location_general_view": (
        "address_english",
        "address_local_language",
        "city_id",
        "city_ml.is_title_approved",
        "city_ml.title",
        "coordinate",
        "country_id",
        "country_ml.is_title_approved",
        "country_name",
        "county_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_approved",
        "is_community_active",
        "is_test_data",
        "location.is_title_approved",
        "location_id",
        "location_ml.title",
        "neighborhood_id",
        "number",
        "phonecode",
        "postal_code",
        "region_id",
        "start_timestamp",
        "state_id",
        "state_ml.is_title_approved",
        "state_ml.title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_list_member_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "location_id",
        "location_list_id",
        "location_list_member_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_list_member_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "location_id",
        "location_list_id",
        "location_list_member_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_list_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "location_list_id",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_ml_table": (
        "created_timestamp",
        "created_user_id",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "location_id",
        "location_ml_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_ml_view": (
        "created_timestamp",
        "created_user_id",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "location_id",
        "location_ml_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_ml_with_deleted_and_test_data_view": (
        "address_english",
        "address_local_language",
        "city_id",
        "coordinate",
        "country_id",
        "county_id",
        "created_timestamp",
        "group_id",
        "identifier",
        "is_approved",
        "is_community_active",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "location.created_effective_profile_id",
        "location.created_effective_user_id",
        "location.created_real_user_id",
        "location.created_timestamp",
        "location.created_user_id",
        "location.end_timestamp",
        "location.is_test_data",
        "location.start_timestamp",
        "location.updated_effective_profile_id",
        "location.updated_effective_user_id",
        "location.updated_real_user_id",
        "location.updated_timestamp",
        "location.updated_user_id",
        "location.visibility_id",
        "location_id",
        "location_ml.created_user_id",
        "location_ml_id",
        "name",
        "neighborhood_id",
        "number",
        "phonecode",
        "postal_code",
        "region_id",
        "state_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_table": (
        "address_english",
        "address_local_language",
        "city_id",
        "city_ml_id",
        "coordinate",
        "country_id",
        "county_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "identifier",
        "is_approved",
        "is_community_active",
        "is_official",
        "is_test_data",
        "location_id",
        "name",
        "neighborhood_id",
        "number",
        "phonecode",
        "postal_code",
        "region_id",
        "start_timestamp",
        "state_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "location_type_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_test_data",
        "lang_code",
        "location_type_id",
        "location_type_ml_id",
        "start_timestamp",
        "title",
        "title_approved",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_type_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "location_type_id",
        "name",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_view": (
        "address_english",
        "address_local_language",
        "city_id",
        "coordinate",
        "country_id",
        "county_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "identifier",
        "is_approved",
        "is_community_active",
        "is_test_data",
        "location_id",
        "name",
        "neighborhood_id",
        "number",
        "phonecode",
        "postal_code",
        "region_id",
        "start_timestamp",
        "state_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "neighborhood_ml_table": (
        "created_timestamp",
        "created_user_id",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "neighborhood_id",
        "neighborhood_ml_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "neighborhood_ml_view": (
        "city_id",
        "group.name",
        "group_id",
        "lang_code",
        "name",
        "neighborhood.end_timestamp",
        "neighborhood_id",
        "title"
    ),
    "neighborhood_ml_with_deleted_and_test_data_view": (
        "city_id",
        "created_timestamp",
        "created_user_id",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "neighborhood_id",
        "neighborhood_ml_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "neighborhood_table": (
        "city_id",
        "coordinate",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "is_test_data",
        "name",
        "neighborhood_id",
        "number",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "neighborhood_view": (
        "city_id",
        "coordinate",
        "created_timestamp",
        "created_user_id",
        "group_id",
        "is_test_data",
        "neighborhood_id",
        "number",
        "updated_timestamp",
        "updated_user_id"
    ),
    "region_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "region_id",
        "region_ml_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "region_ml_view": (
        "country_id",
        "group.name",
        "group_id",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "region_id",
        "title"
    ),
    "region_ml_with_deleted_and_test_data_view": (
        "country_id",
        "created_timestamp",
        "created_user_id",
        "group_id",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "region.end_timestamp",
        "region_id",
        "region_ml.end_timestamp",
        "region_ml_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "region_table": (
        "coordinate",
        "country_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "is_test_data",
        "name",
        "number",
        "region_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "state_list_member_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "state_id",
        "state_list_id",
        "state_list_member_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "state_list_member_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "state_id",
        "state_list_id",
        "state_list_member_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "state_list_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "name",
        "start_timestamp",
        "state_list_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "state_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "state_abbr",
        "state_abbr_approved",
        "state_id",
        "state_ml_id",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "state_ml_view": (
        "is_title_approved",
        "lang_code",
        "state_id",
        "title"
    ),
    "state_table": (
        "coordinate",
        "country_id",
        "created_timestamp",
        "created_user_id",
        "end_timestmap",
        "group_id",
        "is_test_data",
        "name",
        "number",
        "state_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "location_location_type_geneal_view": (
        "location.name",
        "location_id",
        "location_location_type_id",
        "location_ml.title",
        "location_ml_id",
        "location_type.name",
        "location_type_id",
        "location_type_ml.title",
        "location_type_ml_id"
    ),
    "location_location_type_table": (
        "location_id",
        "location_location_type_id",
        "location_ml_id",
        "location_type_id",
        "location_type_ml_id"
    ),
    "location_location_type_view": (
        "location_id",
        "location_location_type_id",
        "location_ml_id",
        "location_type_id",
        "location_type_ml_id"
    ),
    "location_profile_general_view": (
        "address_english",
        "address_local_language",
        "city_id",
        "coordinate",
        "country_id",
        "county_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "identifier",
        "is_approved",
        "is_community_active",
        "is_test_data",
        "location_id",
        "location_profile_id",
        "name",
        "neighborhood_id",
        "number",
        "phonecode",
        "postal_code",
        "profile_id",
        "region_id",
        "start_timestamp",
        "state_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "location_profile_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "lang_code",
        "location_profile_id",
        "location_profile_ml_id",
        "start_timestamp",
        "title",
        "title_approved",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "location_profile_ml_view": (
        "created_effective_profile_id",
        "lang_code",
        "location_id",
        "location_profile_id",
        "profile_id",
        "title",
        "visibility_id"
    ),
    "location_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "location_id",
        "location_profile_id",
        "location_type_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "location_profile_view": (
        "created_effective_profile_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "location_id",
        "location_profile_id",
        "profile_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "Groups Not Approved": (
        "Group Category"
    ),
    "logger_action_view": (
        "action_id",
        "destination system name",
        "name",
        "source system name",
        "timestamp"
    ),
    "logger_all_fields_updates": (
        "internal_description",
        "name",
        "variable.name",
        "Website"
    ),
    "logger_dialog_workflow_state_history_view": (
        "created_timestamp",
        "profile_id",
        "state_id",
        "timestamp",
        "variable_id",
        "variable_value_new",
        "variable_value_old"
    ),
    "logger_function_start_end_view": (
        "component.component_name",
        "component.developer_email",
        "component_id",
        "created_timestamp",
        "function_name",
        "logger.component_name",
        "logger.developer_email",
        "logger_id",
        "process_id",
        "session",
        "severity_description",
        "severity_id",
        "thread_id"
    ),
    "logger_group_profile_view": (
        "activity",
        "activity_id",
        "client_ip_v4",
        "client_ip_v6",
        "component name",
        "component_id",
        "created_timestamp",
        "created_user_id",
        "end_datetime",
        "error_stack",
        "group_id",
        "location_id",
        "logger_id",
        "message",
        "payload",
        "profile_id",
        "programming_language",
        "relationship_type_id",
        "server_ip_v4",
        "server_ip_v6",
        "severity_id",
        "start_datetime",
        "state_id",
        "status_id",
        "timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "variable_id",
        "variable_value_new",
        "variable_value_old"
    ),
    "logger_last_session_general_view": (
        "created_timestamp",
        "session"
    ),
    "logger_last_session_view": (
        "created_timestamp",
        "created_user_id",
        "session"
    ),
    "logger_logger_general_view": (
        "activity",
        "activity_id",
        "client_ip_v4",
        "client_ip_v6",
        "component_id",
        "created_timestamp",
        "created_user_id",
        "end_datetime",
        "error_stack",
        "group_id",
        "location_id",
        "logger_id",
        "message",
        "name",
        "payload",
        "profile_id",
        "relationship_type_id",
        "server_ip_v4",
        "server_ip_v6",
        "severity_id",
        "start_datetime",
        "state_id",
        "status_id",
        "timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "variable_id",
        "variable_value_new",
        "variable_value_old"
    ),
    "logger_records_of_last_session_view": (
        "class_name",
        "component_id",
        "component_name",
        "created_timestamp",
        "error_stack",
        "function_name",
        "line_number",
        "logger_id",
        "message",
        "payload",
        "profile_id",
        "session",
        "severity_id",
        "status_id",
        "user_id"
    ),
    "logger_sessions_group_by_day_view": (
        "COUNT(*)",
        "date"
    ),
    "logger_sessions_order_by_timestamp_view": (
        "COUNT(*)",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "main_email",
        "profile_id",
        "session",
        "user_id"
    ),
    "logger_severity_level_table": (
        "component_id",
        "data_store",
        "environment",
        "environment_id",
        "id",
        "maximal_severity_level",
        "region",
        "region_id"
    ),
    "logger_start_end_group_by_component_date_view": (
        "component_id",
        "component_name",
        "COUNT(*)",
        "DATE(created_timestamp)"
    ),
    "logger_table": (
        "action_id",
        "activity",
        "activity_id",
        "api_type",
        "api_type_id",
        "class_name",
        "client_ip_v4",
        "client_ip_v6",
        "component_category",
        "component_id",
        "component_name",
        "component_type",
        "compound_message",
        "computer_language",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "destination_emails",
        "developer_email",
        "end_datetime",
        "end_timestamp",
        "error_stack",
        "field_id",
        "field_value_new",
        "field_value_old",
        "filename",
        "form_id",
        "function_name",
        "group_id",
        "group_id1",
        "group_id2",
        "identifier",
        "is_assertion_error",
        "is_test_data",
        "line_number",
        "locals_before_exception",
        "location_id",
        "logger_id",
        "message",
        "message_id",
        "message_template_id",
        "message_template_text_block_id",
        "number",
        "path",
        "payload",
        "process_id",
        "profile_id",
        "question_id",
        "reaction_id",
        "real_name",
        "recipient",
        "record",
        "relationship_type_id",
        "result",
        "return_code",
        "return_message",
        "returned_value",
        "server_ip_v4",
        "server_ip_v6",
        "session",
        "severity_id",
        "smartlink_id",
        "smartlink_identifier",
        "source_email",
        "sql_formatted",
        "sql_parameters",
        "sql_statement",
        "start_datetime",
        "start_timestamp",
        "state_id",
        "status_id",
        "stderr",
        "stdout",
        "testing_framework",
        "text_block_id",
        "thread_id",
        "timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "user_identifier",
        "variable_id",
        "variable_value_new",
        "variable_value_old"
    ),
    "logger_table_old": (
        "activity",
        "activity_id",
        "component_id",
        "created_timestamp",
        "created_user_id",
        "end_datetime",
        "id",
        "ipv4",
        "ipv6",
        "location_id",
        "payload",
        "profile_id",
        "severity_id",
        "start_datetime",
        "state_id",
        "timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "variable_id",
        "variable_value_new",
        "variable_value_old"
    ),
    "logger_view": (
        "action_id",
        "activity",
        "activity_id",
        "api_type",
        "api_type_id",
        "client_ip_v4",
        "client_ip_v6",
        "component_category",
        "component_id",
        "component_name",
        "component_type",
        "computer_language",
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "destination_emails",
        "developer_email",
        "end_datetime",
        "error_stack",
        "field_id",
        "field_value_new",
        "field_value_old",
        "function_name",
        "group_id",
        "group_id1",
        "group_id2",
        "is_test_data",
        "location_id",
        "logger_id",
        "message",
        "message_id",
        "message_template_id",
        "message_template_text_block_id",
        "payload",
        "process_id",
        "profile_id",
        "question_id",
        "recipient",
        "record",
        "relationship_type_id",
        "return_code",
        "return_message",
        "returned_value",
        "server_ip_v4",
        "server_ip_v6",
        "session",
        "severity_id",
        "smartlink_identifier",
        "source_email",
        "sql_formatted",
        "sql_parameters",
        "sql_statement",
        "start_datetime",
        "state_id",
        "status_id",
        "stderr",
        "stdout",
        "testing_framework",
        "thread_id",
        "timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "variable_id",
        "variable_value_new",
        "variable_value_old"
    ),
    "severity_ml_en_view": (
        "description",
        "language code",
        "severity id",
        "severity_ml_id"
    ),
    "severity_ml_table": (
        "description",
        "lang_code",
        "severity_id",
        "severity_ml_id",
        "title"
    ),
    "severity_table": (
        "created_timestamp",
        "created_user_id",
        "end_datetime",
        "level",
        "name",
        "severity_id",
        "start_datetime",
        "updated_timestamp",
        "updated_user_id"
    ),
    "severity_table_m_old": (
        "description",
        "description_approved",
        "id",
        "lang_code",
        "severity_id"
    ),
    "severity_table_old": (
        "created_timestamp",
        "created_user_id",
        "end_datetime",
        "id",
        "start_datetime",
        "updated_timestamp",
        "updated_user_id"
    ),
    "severity_view": (
        "created timestamp",
        "created user id",
        "severity id",
        "updated timestamp",
        "updated user id"
    ),
    "status_table": (
        "created_timestamp",
        "created_user_id",
        "end_datetime",
        "id",
        "start_datetime",
        "updated_timestamp",
        "updated_user_id"
    ),
    "status_table_ml": (
        "description",
        "id",
        "lang_code",
        "status_id"
    ),
    "mailbox_profile_table": (
        "mailbox_id",
        "mailbox_profile_id",
        "name",
        "profile_id"
    ),
    "base_entity_table": (
        "base_entity_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "buyer_ml_table": (
        "buyer_id",
        "buyer_ml_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "buyer_ml_view": (
        "coordinate",
        "entity_id",
        "name"
    ),
    "buyer_table": (
        "buyer_id",
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "end_timestamp",
        "profile_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "cloud_vendor_table": (
        "cloud_vendor_id",
        "seller_id"
    ),
    "consumer_category_table": (
        "consumer_category_id"
    ),
    "participant_category_table": (
        "participant_category_id"
    ),
    "product_table": (
        "product_id"
    ),
    "product_url_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "product_id",
        "product_url_id",
        "start_timestamp",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "url_type_id"
    ),
    "proxy_group_list_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "proxy_profile": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "seller_category_table": (
        "seller_category_id"
    ),
    "seller_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "seller_id",
        "seller_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "seller_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "name",
        "profile_id",
        "seller_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "accommodation_deal_table": (
        "accommodation_deal_id",
        "accommodation_id",
        "end_date",
        "hospitlity",
        "room_type",
        "start_date"
    ),
    "accommodation_table": (
        "accommodation_id"
    ),
    "goods_ml_table": (
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "goods_id",
        "goods_ml_id",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "goods_potential_view": (
        "coordinate",
        "created_user_id",
        "entity_id",
        "entity_type_id",
        "lang_code",
        "location_id",
        "title",
        "updated_timestamp",
        "visibility_id"
    ),
    "goods_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "goods_id",
        "group_list_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "product_deal_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "is_title_approved",
        "lang_code",
        "product_deal_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "product_deal_table": (
        "created_timestamp",
        "created_user_id",
        "currency_id",
        "end_timestamp",
        "max_price_set_id",
        "min_price_set_id",
        "price_set_id",
        "product_deal_id",
        "product_id",
        "quantity",
        "regular_price",
        "shop_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "url"
    ),
    "shop_ml_table": (
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "id",
        "is_title_approved",
        "lang_code",
        "shop_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "shop_seller_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "role",
        "seller_id",
        "shop_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "shop_table": (
        "coordinate",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "owner_seller_id",
        "shop_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "real_estate_criteria_table": (
        "agent_profile_id",
        "budget_local_currency",
        "budget_usd",
        "buyer_profile_id",
        "cash_guarentee_local_currency",
        "criteria_id",
        "currency",
        "has_cheq",
        "name",
        "requested_entrance_date"
    ),
    "real_estate_listing_table": (
        "agent_name",
        "agent_office_phone",
        "building_size",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "land_size",
        "num_of_bathrooms",
        "num_of_bedrooms",
        "number",
        "price",
        "property_type",
        "real_estate_listing_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "real_estate_listing_view": (
        "agent_name",
        "agent_office_phone",
        "building_size",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "land_size",
        "num_of_bathrooms",
        "num_of_bedrooms",
        "number",
        "price",
        "property_type",
        "real_estate_listing_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "price_set_currency_table": (
        "country_id",
        "currency_id",
        "price",
        "price_set_currency_id",
        "price_set_id"
    ),
    "price_set_range_table": (
        "price_set_range_id"
    ),
    "price_set_table": (
        "price_set_id"
    ),
    "resource_instance_ml_table": (
        "id",
        "language",
        "name",
        "resource_instance_id"
    ),
    "resource_instance_table": (
        "google_calendar",
        "id",
        "resource_id",
        "seq"
    ),
    "resource_ml_table": (
        "id",
        "language",
        "name",
        "resource_id"
    ),
    "resource_table": (
        "buy_price_set",
        "buy_price_usd",
        "location_id",
        "resource_id",
        "resource_type_id",
        "sell_price_set",
        "sell_price_usd"
    ),
    "resource_type_ml_table": (
        "id",
        "language",
        "name",
        "resource_type_id"
    ),
    "resource_type_table": (
        "activity_type",
        "id"
    ),
    "message_template_rfp_table": (
        "message_template_id",
        "message_template_rfp_id",
        "rfp_id"
    ),
    "rfp_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "rfp_id",
        "rfp_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "rfp_referral_table": (
        "buyer_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "message_id",
        "number",
        "press_link_in_content_message_timestamp",
        "rfp_id",
        "rfp_referral_id",
        "seller_approach_buyer_using_message_to_email_timestamp",
        "seller_approach_buyer_using_message_to_phone_timestamp",
        "seller_exposed_buyer_address_timestmap",
        "seller_exposed_buyer_email_address_timestmap",
        "seller_exposed_buyer_phone_timestmap",
        "seller_exposed_rfp_details_timestmap",
        "seller_id",
        "seller_interested_in_rfp_timestamp",
        "seller_interested_that_buyer_will_approach_seller_timestamp",
        "seller_interested_to_approach_buyer_timestamp",
        "smartlink_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "rfp_requirements_table": (
        "field_id",
        "max_value",
        "min_value",
        "pririty",
        "rfp_id",
        "rfp_requirements_id"
    ),
    "rfp_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "goods_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "rfp_id",
        "service_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "is_title_approved",
        "lang_code",
        "service_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_offer_location_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "extra_price",
        "id",
        "location_list_id",
        "service_offer_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_offer_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "is_title_approved",
        "lang_code",
        "service_offer_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_offer_table": (
        "base_price",
        "created_timestamp",
        "created_user_id",
        "currency_id",
        "end_timestamp",
        "experience",
        "id",
        "reaction_id",
        "reaction_value",
        "service_id",
        "service_provider_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_order_table": (
        "created_timestamp",
        "created_user_id",
        "currency_id",
        "end_timestamp",
        "id",
        "location_id",
        "order_time",
        "price",
        "service_offer_id",
        "service_provider_id",
        "service_receiver_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_provider_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "is_title_approved",
        "lang_code",
        "service_provider_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_provider_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "profile_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_receiver_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "is_title_approved",
        "lang_code",
        "service_receiver_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_receiver_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "profile_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_review_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "is_title_approved",
        "lang_code",
        "service_review_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_review_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "order_id",
        "reaction_id",
        "reaction_value",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "service_id",
        "service_type_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "service_type_table": (
        "service_type_id"
    ),
    "lesson_table": (
        "created_timestamp",
        "created_user_id",
        "description",
        "duration_minutes",
        "end_timestamp",
        "lesson_id",
        "platform",
        "price_local_currency",
        "start_timestamp",
        "teacherId",
        "updated_timestamp",
        "updated_user_id"
    ),
    "platform_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "number",
        "platform_id",
        "platform_name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "student_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "full_name",
        "start_timestamp",
        "student_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "teacher_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "fullName",
        "start_timestamp",
        "teacher_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "channel_provider_table": (
        "channel_provider_id",
        "message_channel_id",
        "message_provider_id"
    ),
    "conversation_ml_table": (
        "conversation_id",
        "conversation_ml_table",
        "lang_code",
        "title"
    ),
    "conversation_table": (
        "conversation_id",
        "name",
        "profile_list_id"
    ),
    "message_channel_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "message_channel_id",
        "message_channel_ml_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_channel_provider_ml_table": (
        "lang_code",
        "message_channel_provider_ml_id",
        "message_provider_id",
        "message_provider_name"
    ),
    "message_channel_provider_table": (
        "message_channel_provider_id",
        "provider_name",
        "supplier_id"
    ),
    "message_channel_table": (
        "chanel_type_id",
        "message_channel_id",
        "name",
        "version"
    ),
    "message_content_ml_table": (
        "body",
        "channel_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "message_content_id",
        "message_content_ml_id",
        "start_timestamp",
        "subeject",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_content_table": (
        "content_type_id",
        "message_content_id",
        "message_id",
        "version"
    ),
    "message_outbox_view": (
        "action_id",
        "campaign_id",
        "class_parameters_json",
        "compound_message",
        "compound_message_json",
        "compound_message_json_version",
        "exection_end_time",
        "exection_start_time",
        "function_parameters_json",
        "identifier",
        "is_test_data",
        "label_id",
        "message_id",
        "message_label_title",
        "number",
        "process_id",
        "queue_status_id",
        "queue_status_title",
        "return_code",
        "server_ip_v4",
        "server_ip_v6",
        "stderr",
        "stdout",
        "thread_id",
        "updated_timestamp",
        "user_jwt"
    ),
    "message_outgoing_table_shall_we_delete_it": (
        "actual_sent_timestamp",
        "bcc_profile_id",
        "cc_profile_id",
        "from_profile_id",
        "message_channel_id",
        "message_outgoing_id",
        "message_type_id",
        "request_to_send_timestamp",
        "scheduled_sent_timestamp",
        "sending_message_result_id",
        "timestamp",
        "to_profile_id"
    ),
    "message_read_table": (
        "channel_id",
        "message_id",
        "message_read_id",
        "profile_id",
        "timestamp"
    ),
    "message_sent_table": (
        "message_channel_id",
        "message_id",
        "message_sent_id",
        "request_to_send_timestamp",
        "sender_profile_id",
        "sent_timestamp"
    ),
    "message_sent_view": (
        "actual_send_timestamp",
        "identifier",
        "label_id",
        "message_id",
        "number",
        "visibility_id"
    ),
    "message_status_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "message_status_type_id",
        "message_status_type_ml_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_status_type_table": (
        "message_status_id",
        "name"
    ),
    "message_table": (
        "action_id",
        "actual_channel_id",
        "actual_sent_timestamp",
        "bcc_email",
        "bcc_profile_id",
        "bcc_profile_list_id",
        "body",
        "campaign_criteria_set_id",
        "campaign_id",
        "cc_email",
        "cc_profile_id",
        "cc_profile_list_id",
        "channel_id",
        "class_parameters_json",
        "compound_message",
        "compound_message_json",
        "compound_message_json_version",
        "conversation_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "dialog_workflow_state_id",
        "email_message_id",
        "end_timestamp",
        "function_parameters_json",
        "group_id",
        "group_list_id",
        "identifier",
        "is_gen_ai",
        "is_moderator_approved",
        "is_pin",
        "is_push_notification",
        "is_require_moderator",
        "is_test_data",
        "location_id",
        "machine_learning_model_id",
        "mailbox_id",
        "message_channel_id",
        "message_id",
        "message_message_relationship_id",
        "message_status_id",
        "message_type_id",
        "moderator_feedback_text",
        "moderator_feedback_type",
        "moderator_profile_id",
        "number",
        "occurrence_id",
        "original_message_id",
        "parent_message_id",
        "process_id",
        "profile_id",
        "provider_id",
        "queue_status_id",
        "request_to_send_timestamp",
        "requested_channel_id",
        "return_code",
        "return_message",
        "returned_value",
        "scheduled_sent_timestamp",
        "sender_email",
        "sender_profile_id",
        "server_ip_v4",
        "server_ip_v6",
        "session",
        "session_id",
        "source_subsystem_id",
        "start_timestamp",
        "stderr",
        "stdout",
        "subject",
        "thread_id",
        "to_email",
        "to_profile_id",
        "to_profile_list_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_jwt",
        "visibility_id"
    ),
    "message_type_ml_table": (
        "body",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "message_type_id",
        "message_type_ml_id",
        "start_timestamp",
        "subeject",
        "type_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_type_table": (
        "channel_type_id",
        "message_type_table_id",
        "version"
    ),
    "message_view": (
        "action_id",
        "actual_channel_id",
        "actual_sent_timestamp",
        "bcc_email",
        "bcc_profile_id",
        "bcc_profile_list_id",
        "body",
        "campaign_id",
        "cc_email",
        "cc_profile_id",
        "cc_profile_list_id",
        "class_parameters_json",
        "compound_message",
        "compound_message_json",
        "compound_message_json_version",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_message_id",
        "end_timestamp",
        "function_parameters_json",
        "group_id",
        "group_list_id",
        "identifier",
        "is_gen_ai",
        "is_moderator_approved",
        "is_pin",
        "is_push_notification",
        "is_require_moderator",
        "is_test_data",
        "location_id",
        "machine_learning_model_id",
        "mailbox_id",
        "message_channel_id",
        "message_id",
        "message_message_relationship_id",
        "message_status_id",
        "message_type_id",
        "moderator_feedback_text",
        "moderator_feedback_type",
        "moderator_profile_id",
        "number",
        "occurrence_id",
        "parent_message_id",
        "process_id",
        "profile_id",
        "provider_id",
        "queue_status_id",
        "request_to_send_timestamp",
        "requested_channel_id",
        "return_code",
        "return_message",
        "returned_value",
        "scheduled_sent_timestamp",
        "sender_email",
        "sender_profile_id",
        "server_ip_v4",
        "server_ip_v6",
        "session",
        "session_id",
        "start_timestamp",
        "stderr",
        "stdout",
        "subject",
        "thread_id",
        "to_email",
        "to_profile_id",
        "to_profile_list_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_jwt",
        "visibility_id"
    ),
    "message_channel_content_set_profile_table": (
        "content_set_id",
        "is_opt_out",
        "is_subscribed",
        "message_channel_content_set_profile_table",
        "message_channel_id",
        "profile_id"
    ),
    "message_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "message_id",
        "message_profile_id",
        "message_status_id",
        "number",
        "profile_id",
        "reaction_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_id"
    ),
    "message_profile_view": (
        "message_id",
        "message_profile_id",
        "message_status_id",
        "profile_id",
        "reaction_id",
        "user_id"
    ),
    "message_template_function_table": (
        "description",
        "is_expression",
        "is_function",
        "message_template_function_id",
        "name"
    ),
    "message_template_general_view": (
        "action_id",
        "action_name",
        "default_body_template",
        "default_question_possible_answer_id",
        "default_subject_template",
        "email_body_html_template",
        "email_subject_template",
        "field_id",
        "field_name",
        "message_template_id",
        "message_template_name",
        "message_template_text_block.criteria.name",
        "message_template_text_block.criteria_id_old",
        "message_template_text_block.criteria_set_id",
        "message_template_text_block_id",
        "message_template_text_block_is_visible",
        "message_template_text_block_ml_lang_code",
        "message_template_text_block_name",
        "message_template_text_block_seq",
        "message_template_text_block_type.title",
        "possible_answer",
        "question.title",
        "question_hint",
        "question_id",
        "question_is_required",
        "question_ml_lang_code",
        "question_type_id",
        "question_type_name",
        "question_type_schema_attributes",
        "question_type_uischema_attributes",
        "schema_attributes",
        "sms_body_template",
        "uischema_attributes",
        "variable_id",
        "variable_ml_title",
        "variable_name",
        "whatsapp_body_template"
    ),
    "message_template_message_template_text_block_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "message_template_id",
        "message_template_message_template_text_block_id",
        "message_template_text_block_id",
        "message_template_text_block_type_id",
        "seq",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_template_message_template_text_block_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "message_template_id",
        "message_template_message_template_text_block_id",
        "message_template_message_template_text_block_type_id",
        "message_template_text_block_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_template_table": (
        "message_template_id",
        "name"
    ),
    "message_template_text_block_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "default_body_template",
        "default_subject_template",
        "email_body_html_template",
        "email_subject_template",
        "end_timestamp",
        "gender_id",
        "identifier",
        "is_test_data",
        "lang_code",
        "message_template_text_block_id",
        "message_template_text_block_ml_id",
        "number",
        "smartlink_type_id",
        "sms_body_template",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "whatsapp_body_template"
    ),
    "message_template_text_block_ml_view": (
        "default_body_template",
        "default_subject_template",
        "email_body_html_template",
        "email_subject_template",
        "lang_code",
        "message_template_text_block_id",
        "message_template_text_block_ml_id",
        "sms_body_template",
        "whatsapp_body_template"
    ),
    "message_template_text_block_question_review_view": (
        "default_body_template",
        "lang_code",
        "message_template_text_block_id",
        "name",
        "question_id"
    ),
    "message_template_text_block_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "criteria_id_old",
        "criteria_set_id",
        "end_timestamp",
        "is_test_data",
        "is_visible",
        "message_template_text_block_id",
        "message_template_text_block_type_id",
        "name",
        "question_id",
        "seq_old",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_template_text_block_type_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "lang_code",
        "message_template_text_block_type_id",
        "message_template_text_block_type_ml_id",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_template_text_block_type_ml_view": (
        "lang_code",
        "message_template_text_block_type_id",
        "message_template_text_block_type_ml_id",
        "title"
    ),
    "message_template_text_block_type_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "message_template_text_block_type_id",
        "name",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "message_template_view": (
        "message_template_id",
        "name"
    ),
    "first_name_alias_table": (
        "first_name_alias_id",
        "first_name_id1",
        "first_name_id2"
    ),
    "first_name_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "first_name_id",
        "first_name_ml_id",
        "identifier",
        "is_description_approved",
        "is_main",
        "is_name_approved",
        "is_test_data",
        "lang_code",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "first_name_ml_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "first_name_id",
        "first_name_ml_id",
        "identifier",
        "is_description_approved",
        "is_main",
        "is_name_approved",
        "is_test_data",
        "lang_code",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "first_name_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "first_name_id",
        "gender_id",
        "gender_list_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "first_name_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "first_name_id",
        "gender_id",
        "gender_list_id",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "last_name_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "identifier",
        "is_description_approved",
        "is_main",
        "is_name_approved",
        "is_test_data",
        "lang_code",
        "last_name_id",
        "last_name_ml_id",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "last_name_ml_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "identifier",
        "is_description_approved",
        "is_main",
        "is_name_approved",
        "is_test_data",
        "lang_code",
        "last_name_id",
        "last_name_ml_id",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "last_name_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "last_name_id",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "last_name_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "last_name_id",
        "name",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "operational_hours_table": (
        "created_timestamp",
        "created_user_id",
        "day_of_week",
        "end_timestamp",
        "from_time",
        "is_business_hours",
        "is_test_data",
        "location_id",
        "occurence_id",
        "operational_hours_id",
        "operational_hours_type",
        "profile_id",
        "start_timestamp",
        "until_time",
        "updated_timestamp",
        "updated_user_id"
    ),
    "operational_hours_view": (
        "created_timestamp",
        "created_user_id",
        "day_of_week",
        "end_timestamp",
        "from_time",
        "is_business_hours",
        "is_test_data",
        "location_id",
        "occurence_id",
        "operational_hours_id",
        "operational_hours_type",
        "profile_id",
        "start_timestamp",
        "until_time",
        "updated_timestamp",
        "updated_user_id"
    ),
    "organization_approved_en_main_view": (
        "description",
        "organization_id",
        "parent_organization_id"
    ),
    "organization_ml_not_deleted_view": (
        "lang_code",
        "name",
        "organization_id",
        "organization_ml_id",
        "title"
    ),
    "organization_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "identifier",
        "is_description_approved",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "organization_id",
        "organization_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "organization_ml_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "identifier",
        "is_description_approved",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "organization_id",
        "organization_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "organization_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_approved",
        "is_main",
        "is_test_data",
        "location_id",
        "main_group_id",
        "members_visibility_scope_id",
        "name",
        "Non_members_visibility_profile_id",
        "non_members_visibility_scope_id",
        "number",
        "organization_id",
        "parent_organization_id",
        "point",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "organization_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_approved",
        "is_main",
        "is_test_data",
        "location_id",
        "main_group_id",
        "members_visibility_scope_id",
        "name",
        "Non_members_visibility_profile_id",
        "non_members_visibility_scope_id",
        "number",
        "organization_id",
        "parent_organization_id",
        "point",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "organization_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "job_title_id",
        "job_title_ml_id",
        "number",
        "organization_id",
        "organization_ml_id",
        "organization_profile_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "organization_profile_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "job_title_id",
        "job_title_ml_id",
        "number",
        "organization_id",
        "organization_profile_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "people_criteria_general_view": (
        "city_id",
        "coordinate",
        "country_id_old",
        "created_timestamp",
        "created_user_id",
        "criteria.name",
        "criteria_id",
        "end_timestamp",
        "entity_type_id",
        "gender_list_id",
        "group_id",
        "group_id_old",
        "group_list_id",
        "international_code",
        "international_code_old",
        "internet_domain_id",
        "internet_domain_id_old",
        "internet_domain_list_id",
        "internet_domain_list_id_old",
        "is_test_data",
        "job_group_list_id",
        "job_group_list_id_old",
        "job_location_list_id",
        "job_location_list_id_old",
        "job_types_id",
        "job_types_id_old",
        "label_id",
        "location_id",
        "location_list_id",
        "max_age",
        "max_height",
        "max_kids_age",
        "max_number_of_kids",
        "min_age",
        "min_height",
        "min_kids_age",
        "min_number_of_kids",
        "number_of_partners",
        "organization_name",
        "organization_name_old",
        "partner_experience_level",
        "people_criteria.created_timestamp",
        "people_criteria.created_user_id",
        "people_criteria.end_timestamp",
        "people_criteria.is_test_data",
        "people_criteria.name",
        "people_criteria.start_timestamp",
        "people_criteria.updated_timestamp",
        "people_criteria.updated_user_id",
        "people_criteria.user_external_id",
        "profile_list_id",
        "profile_list_id_old",
        "radius",
        "radius_km",
        "radius_measure",
        "start_date_type_id",
        "start_date_type_id_old",
        "start_timestamp",
        "template_condition_2delete",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "vacancy_list_id",
        "vacancy_list_id_old",
        "visibility_id",
        "where_sql",
        "workplace_profile_list_id",
        "workplace_profile_list_id_old"
    ),
    "people_criteria_review_view": (
        "criteria.name",
        "criteria_id",
        "max_age",
        "min_age",
        "people_criteria.name"
    ),
    "people_criteria_table": (
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "end_timestamp",
        "gender_list_id",
        "group_id",
        "international_code",
        "internet_domain_id",
        "internet_domain_list_id",
        "is_test_data",
        "job_group_list_id",
        "job_location_list_id",
        "job_types_id",
        "max_age",
        "max_height",
        "max_kids_age",
        "max_number_of_kids",
        "min_age",
        "min_height",
        "min_kids_age",
        "min_number_of_kids",
        "name",
        "number_of_partners",
        "organization_name",
        "partner_experience_level",
        "profile_list_id",
        "start_date_type_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "vacancy_list_id",
        "workplace_profile_list_id"
    ),
    "people_criteria_ext_view": (
        "created_timestamp",
        "created_user_id",
        "criteria_id",
        "end_timestamp",
        "gender_list_id",
        "group_id",
        "international_code",
        "internet_domain_id",
        "internet_domain_list_id",
        "is_test_data",
        "job_group_list_id",
        "job_location_list_id",
        "job_types_id",
        "max_age",
        "max_height",
        "max_kids_age",
        "max_number_of_kids",
        "min_age",
        "min_height",
        "min_kids_age",
        "min_number_of_kids",
        "name",
        "number_of_partners",
        "organization_name",
        "partner_experience_level",
        "profile_list_id",
        "start_date_type_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "vacancy_list_id",
        "workplace_profile_list_id"
    ),
    "circlez_team_members": (
        "Email",
        "First Name",
        "Gender",
        "Last Name",
        "Number",
        "Roles",
        "Skills",
        "Team(s)",
        "Title"
    ),
    "person_contact_general_view": (
        "contact_created_timestamp",
        "contact_email_address1",
        "contact_first_name",
        "contact_id",
        "contact_person_type_id",
        "contact_person_type_name",
        "first_name",
        "last_name",
        "main_email_person",
        "person_created_timestamp",
        "person_id"
    ),
    "person_general_view": (
        "first_name",
        "last_name",
        "main_email_person",
        "number_of_contacts",
        "number_of_phones",
        "number_of_profiles",
        "person_birthday_date",
        "person_created_timestamp",
        "person_end_timestamp",
        "person_id",
        "person_is_test_data",
        "person_profile_end_timestamp",
        "profile.main_email_address",
        "profile.main_user_id",
        "profile.name",
        "profile_end_timestamp",
        "profile_id",
        "profile_is_test_data"
    ),
    "person_in_all_table_view": (
        "COUNT(person_id)"
    ),
    "person_kid_table": (
        "number_of_kids",
        "person_id",
        "person_kids_id"
    ),
    "person_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "end_timestamp",
        "first_name",
        "identifier",
        "is_first_name_approved",
        "is_last_name_approved",
        "is_test_data",
        "lang_code",
        "last_name",
        "number",
        "person_id",
        "person_ml_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "visibility_id"
    ),
    "person_ml_view": (
        "first_name",
        "is_first_name_approved",
        "is_last_name_approved",
        "is_test_data",
        "lang_code",
        "last_name",
        "person_id",
        "person_ml_id"
    ),
    "person_phone_general_view": (
        "area_code",
        "full_number_normalized",
        "internationa_code",
        "person.is_test_data",
        "person_id",
        "person_phone_id",
        "phone.is_test_data",
        "phone_id"
    ),
    "person_probably_test_data_view": (
        "first_name",
        "is_test_data",
        "last_name",
        "main_email_person",
        "person_id"
    ),
    "person_table": (
        "birthday_date",
        "birthday_original",
        "birthday_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "day",
        "end_timestamp",
        "father_name",
        "first_name",
        "gender_id",
        "identifier",
        "is_approved",
        "is_first_name_approved",
        "is_identity_confirmed",
        "is_last_name_approved",
        "is_last_name_auto_generated",
        "is_last_name_sure",
        "is_nickname_approved",
        "is_rip",
        "is_system_data",
        "is_test_data",
        "last_coordinate",
        "last_location_id",
        "last_name",
        "last_name_original",
        "location_id",
        "main_email_person",
        "main_full_number_normalized",
        "main_profile_id",
        "month",
        "name",
        "nickname",
        "number",
        "person_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id",
        "year",
        "year_cira"
    ),
    "person_user_profile_view": (
        "brand_id",
        "first_name",
        "is_main",
        "last_name",
        "login_timestamp",
        "main_email",
        "person_first_name",
        "person_id",
        "person_is_approve",
        "profile stars",
        "profile_id",
        "profile_preferred_lang_code",
        "user stars",
        "user_created_timestamp",
        "user_id"
    ),
    "person_view": (
        "birthday_date",
        "birthday_original",
        "birthday_timestamp",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "day",
        "end_timestamp",
        "father_name",
        "first_name",
        "gender_id",
        "identifier",
        "is_approved",
        "is_first_name_approved",
        "is_identity_confirmed",
        "is_nickname_approved",
        "is_rip",
        "is_test_data",
        "last_coordinate",
        "last_location_id",
        "last_name",
        "location_id",
        "main_email_person",
        "main_full_number_normalized",
        "month",
        "name",
        "nickname",
        "number",
        "person_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id",
        "year",
        "year_cira"
    ),
    "person_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "person_id",
        "person_profile_id",
        "person_profile_role_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "person_profile_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "person_id",
        "person_profile_id",
        "person_profile_role_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "mobile_device": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "os_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_id",
        "version"
    ),
    "os": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "os_name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_general_view": (
        "area_code",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "extension",
        "full_number_normalized",
        "international_code",
        "is_test_data",
        "is_verified",
        "local_number_normalized",
        "number",
        "number_original",
        "phone_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_ml_table": (
        "created_timestamp",
        "created_user_id",
        "lang_code",
        "phone_id",
        "phone_ml_id",
        "title",
        "title_approved",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_review_view": (
        "created_timestamp",
        "full_number_normalized",
        "is_test_data",
        "local_number_normalized",
        "number_original",
        "phone_id"
    ),
    "phone_table": (
        "area_code",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "extension",
        "full_number_normalized",
        "international_code",
        "is_test_data",
        "is_valid",
        "is_verified",
        "local_number_normalized",
        "number",
        "number_original",
        "phone_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_table_old": (
        "approved",
        "approved_timestmp",
        "cira",
        "created_timestamp",
        "created_user_id",
        "end_datetime",
        "id",
        "profile_id",
        "start_datetime",
        "telephone",
        "telephone_label_id",
        "updated_timestamp",
        "updated_user_id",
        "verification_expiration",
        "verification_pin"
    ),
    "phone_view": (
        "area_code",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "extension",
        "full_number_normalized",
        "international_code",
        "is_test_data",
        "local_number_normalized",
        "number",
        "number_original",
        "phone_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_with_empty_full_number_normalized_view": (
        "area_code",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "extension",
        "full_number_normalized",
        "international_code",
        "is_test_data",
        "local_number_normalized",
        "number",
        "number_original",
        "phone_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "mobile_account": (
        "created_timestamp",
        "created_user_id",
        "device_id",
        "end_timestamp",
        "id",
        "name",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "mobile_account_profile": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "id",
        "mobile_account_id",
        "profile_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_profile_general_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "full_number_normalized",
        "is_main",
        "label_phone_id",
        "phone_id",
        "phone_is_test_data",
        "phone_profile_id",
        "phone_profile_is_test_data",
        "profile.main_email_address",
        "profile.name",
        "profile_id",
        "profile_is_test_data",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_profile_main_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "label_phone_id",
        "phone_id",
        "phone_profile_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_test_data",
        "label_phone_id",
        "phone_id",
        "phone_profile_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "phone_profile_verification_table": (
        "phone_profile_id",
        "phone_profile_verification_id"
    ),
    "phone_profile_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "label_phone_id",
        "phone_id",
        "phone_profile_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_approved_en_main_view": (
        "experience_years_min",
        "is_approved",
        "is_main",
        "is_rip",
        "last_dialog_workflow_state_id_old",
        "main_person_id",
        "number",
        "preferred_lang_code",
        "profile.main_user_id",
        "profile_id",
        "profile_type_id",
        "visibility_id"
    ),
    "profile_category_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "profile_category_id",
        "profile_category_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_category_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "profile_category_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_general_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "experience_years_min",
        "internal_description",
        "is_approved",
        "is_main",
        "is_rip",
        "is_system",
        "is_test_data",
        "last_dialog_workflow_state_id",
        "last_dialog_workflow_state_id_old",
        "main_person_id",
        "main_phone_id",
        "number",
        "person.first_name",
        "person.last_name",
        "person.person_id",
        "preferred_lang_code",
        "profile.gender_id",
        "profile.main_email_address",
        "profile.main_person_id",
        "profile.main_user_id",
        "profile.name",
        "profile_id",
        "profile_ml.title",
        "profile_type_id",
        "profile_type_ml.title",
        "stars",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "profile_history_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "field_id",
        "new_value",
        "old_value",
        "profile_history_id",
        "profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_list_member_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "profile_id",
        "profile_list_id",
        "profile_list_member_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_list_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "profile_id",
        "profile_list_id",
        "profile_list_profile_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_list_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "profile_list_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_media_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "lang_code",
        "profile_media_id",
        "profile_media_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_media_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "image",
        "media_licenses_id",
        "media_source_url",
        "media_type_id",
        "profile_id",
        "profile_media_id",
        "start_timestamp",
        "storage_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_ml_table": (
        "about",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_test_data",
        "lang_code",
        "profile_id",
        "profile_ml_id",
        "start_timestamp",
        "title",
        "title_approved",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_ml_view": (
        "lang_code",
        "profile_id",
        "title"
    ),
    "profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "experience_years_min",
        "identifier",
        "internal_description",
        "is_approved",
        "is_business_profile",
        "is_employed",
        "is_looking_for_job",
        "is_main",
        "is_rip",
        "is_system",
        "is_test_data",
        "last_dialog_workflow_state_id_old",
        "main_location_id",
        "main_person_id",
        "main_phone_id",
        "number",
        "preferred_lang_code",
        "profile.gender_id",
        "profile.main_email_address",
        "profile.main_user_id",
        "profile.name",
        "profile_id",
        "profile_type_id",
        "stars",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "profile_type_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "lang_code",
        "profile_type_id",
        "profile_type_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_type_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "profile_type_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_type_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "profile_type_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_user_table_view": (
        "profile_id",
        "profile_user_id",
        "user_id"
    ),
    "profile_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "experience_years_min",
        "identifier",
        "internal_description",
        "is_approved",
        "is_business_profile",
        "is_main",
        "is_rip",
        "is_system",
        "is_test_data",
        "last_dialog_workflow_state_id_old",
        "main_person_id",
        "main_phone_id",
        "number",
        "preferred_lang_code",
        "profile.gender_id",
        "profile.main_email_address",
        "profile.main_user_id",
        "profile.name",
        "profile_id",
        "profile_type_id",
        "stars",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "relationship_classification_table_old": (
        "id"
    ),
    "profile_level_ml_table": (
        "description",
        "id",
        "is_description_approved",
        "is_name_approved",
        "lang_code",
        "name",
        "profile_level_id"
    ),
    "profile_level_table": (
        "profile_id"
    ),
    "profile_metrics_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "profile_id",
        "profile_metrics_id",
        "profile_metrics_type",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "value"
    ),
    "profile_metrics_type_ml_table": (
        "description",
        "is_description_approved",
        "is_main",
        "is_name_approved",
        "is_test_data",
        "lang_code",
        "name",
        "profile_metrics_type_id",
        "profile_metrics_type_ml_id"
    ),
    "profile_metrics_type_table": (
        "profile_metrics_type_id",
        "system_id"
    ),
    "profile_metrics_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "profile_id",
        "profile_metrics_id",
        "profile_metrics_type",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "value"
    ),
    "profile_milestone_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_sure",
        "is_test_data",
        "number",
        "profile_id",
        "profile_milestone_id",
        "start_timestamp",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "profile_milestone_table_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_sure",
        "is_test_data",
        "number",
        "profile_id",
        "profile_milestone_id",
        "start_timestamp",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "profile_page_ml_table": (
        "is_main",
        "lang_code",
        "profile_page_id",
        "profile_page_ml_id",
        "title"
    ),
    "profile_page_table": (
        "is_approved",
        "parent_profile_id",
        "profile_id",
        "profile_page_id"
    ),
    "profile_preference_group_group_table": (
        "profile_preference_group_group_id",
        "profile_preference_group_id",
        "profile_preferences_id"
    ),
    "profile_preference_group_ml_table": (
        "description",
        "is_main",
        "lang_code",
        "name",
        "profile_preference_group_id",
        "profile_preference_group_ml_id"
    ),
    "profile_preference_group_table": (
        "name",
        "profile_preference_group_id"
    ),
    "profile_preference_ml_table": (
        "description",
        "is_main",
        "lang_code",
        "name",
        "profile_preference_id",
        "profile_preference_ml_id"
    ),
    "profile_preference_table": (
        "is_active",
        "preferences_internal_name",
        "profile_id",
        "profile_preference_id",
        "value"
    ),
    "profile_profile_role_ml_table": (
        "lang_code",
        "profile_profile_role_id",
        "profile_profile_role_ml_table",
        "title"
    ),
    "profile_profile_role_table": (
        "profile_profile_role_id"
    ),
    "profile_profile_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_circa",
        "end_date_day",
        "end_date_month",
        "end_date_year",
        "end_timestamp",
        "is_potential",
        "is_system_recommendation",
        "is_test_data",
        "is_user_request",
        "job_title",
        "number",
        "profile_id1",
        "profile_id2",
        "profile_profile_id",
        "profile_profile_role_id",
        "relationship_type_id",
        "start_circa",
        "start_date_day",
        "start_date_month",
        "start_date_year",
        "start_timestamp",
        "system_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "user_external_level"
    ),
    "profile_profile_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_circa",
        "end_date_day",
        "end_date_month",
        "end_date_year",
        "end_timestamp",
        "is_potential",
        "is_system_recommendation",
        "is_test_data",
        "is_user_request",
        "job_title",
        "number",
        "profile_id1",
        "profile_id2",
        "profile_profile_id",
        "profile_profile_role_id",
        "relationship_type_id",
        "start_circa",
        "start_date_day",
        "start_date_month",
        "start_date_year",
        "start_timestamp",
        "system_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "user_external_level"
    ),
    "profile_profile_level_table": (
        "id",
        "profile_id",
        "profile_level_id"
    ),
    "profile_question_table": (
        "answer_number",
        "answer_text",
        "created_timestamp",
        "expiration_timestamp",
        "profile_id",
        "profile_question_id",
        "question_id",
        "user_id"
    ),
    "profile_reaction_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "profile_id",
        "profile_reaction_id",
        "reaction_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_reaction_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "profile_id",
        "profile_reaction_id",
        "reaction_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_storage_table": (
        "profile_id",
        "profile_storage_id",
        "storage_id"
    ),
    "profile_storage_type_ml_table": (
        "lang_code",
        "profile_storage_type_id",
        "profile_storage_type_ml_id",
        "title"
    ),
    "profile_storage_type_table": (
        "file_type_id",
        "name",
        "profile_storage_type_id"
    ),
    "profile_storage_view": (
        "profile_id",
        "profile_storage_id",
        "storage_id"
    ),
    "profile_text_block_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "profile_id",
        "profile_text_block_id",
        "start_timestamp",
        "text_block_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "profile_url_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "profile_id",
        "profile_url_id",
        "start_timestamp",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url_id",
        "url_old",
        "url_type_id_old"
    ),
    "profile_url_view": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_test_data",
        "profile_id",
        "profile_url_id",
        "start_timestamp",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url_id",
        "url_old",
        "url_type_id_old"
    ),
    "profile_user_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_active",
        "is_main",
        "profile_id",
        "profile_user_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_id"
    ),
    "profile_user_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "profile_id",
        "profile_user_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_id"
    ),
    "profile_user_external_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "profile_id",
        "profile_user_external_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id"
    ),
    "profile_user_external_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "profile_id",
        "profile_user_external_id",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id"
    ),
    "profile_variable_table": (
        "answer_number",
        "answer_text",
        "created_timestamp",
        "expiration_timestamp",
        "profile_id",
        "profile_variable_id",
        "variable_id"
    ),
    "person_promotional_message_ml_table": (
        "created_timestamp",
        "created_user_id",
        "lang_code",
        "person_promotional_message_id",
        "person_promotional_message_ml_id",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "person_promotional_message_table": (
        "created_timestamp",
        "created_user_id",
        "criteria_set",
        "dialog_workflow_state_id",
        "is_test_data",
        "join_group_list_id_if_choosen",
        "message_template_id",
        "name",
        "person_id",
        "person_promotional_message_id",
        "priority",
        "promotional_message_id",
        "sql_where",
        "updated_timestamp",
        "updated_user_id"
    ),
    "question_general_view": (
        "field_name",
        "label_question_id",
        "question_default_value",
        "question_id",
        "question_ml_default_value",
        "question_type_id",
        "question_type_name",
        "question_type_schema_attributes",
        "question_typeuischema_attributes",
        "title",
        "value",
        "variable_id",
        "variable_ml_title",
        "variable_name"
    ),
    "question_ml_table": (
        "default_value",
        "gender_id",
        "lang_code",
        "question_id",
        "question_ml_id",
        "title"
    ),
    "question_ml_view": (
        "lang_code",
        "question_id",
        "question_ml_id",
        "title"
    ),
    "question_possible_answer_ml_table": (
        "action_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_approved",
        "is_main",
        "is_test_data",
        "lang_code",
        "number",
        "question_id_old",
        "question_possible_answer_id",
        "question_possible_answer_ml_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "value"
    ),
    "question_possible_answer_ml_view": (
        "action_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_approved",
        "is_main",
        "is_test_data",
        "lang_code",
        "number",
        "question_id_old",
        "question_possible_answer_id",
        "question_possible_answer_ml_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "value"
    ),
    "question_possible_answer_table": (
        "question_id",
        "question_possible_answer_id"
    ),
    "question_possible_answer_view": (
        "question_id",
        "question_possible_answer_id"
    ),
    "question_table": (
        "answer_expiration_days",
        "default_question_possible_answer_id",
        "default_value",
        "hint",
        "is_required",
        "is_visible",
        "label_question_id",
        "name",
        "question_id",
        "question_type_id",
        "schema_attributes",
        "table_id",
        "uischema_attributes",
        "variable_id",
        "where_statement"
    ),
    "question_view": (
        "answer_expiration_days",
        "default_question_possible_answer_id",
        "default_value",
        "hint",
        "is_required",
        "is_visible",
        "label_question_id",
        "name",
        "question_id",
        "question_type_id",
        "schema_attributes",
        "table_id",
        "uischema_attributes",
        "variable_id",
        "where_statement"
    ),
    "question_type_table": (
        "component_name",
        "name",
        "parent_question_type_id",
        "question_type_id",
        "schema_attributes",
        "uischema_attributes"
    ),
    "question_type_view": (
        "component_name",
        "name",
        "parent_question_type_id",
        "question_type_id",
        "schema_attributes",
        "uischema_attributes"
    ),
    "queue_item_table": (
        "action_id",
        "class_parameters_json",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "execution_end_time",
        "execution_start_time",
        "function_parameters_json",
        "identifier",
        "is_test_data",
        "item_description",
        "number",
        "process_id",
        "queue_item_id",
        "queue_status_id",
        "return_code",
        "return_json",
        "return_message",
        "returned_value",
        "server_ip_v4",
        "server_ip_v6",
        "start_timestamp",
        "stderr",
        "stdout",
        "thread_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_jwt"
    ),
    "queue_item_view": (
        "action_id",
        "class_parameters_json",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "execution_end_time",
        "execution_start_time",
        "function_parameters_json",
        "identifier",
        "is_test_data",
        "item_description",
        "number",
        "process_id",
        "queue_item_id",
        "queue_status_id",
        "return_code",
        "return_json",
        "return_message",
        "returned_value",
        "server_ip_v4",
        "server_ip_v6",
        "start_timestamp",
        "stderr",
        "stdout",
        "thread_id",
        "updated_timestamp",
        "updated_user_id",
        "user_jwt"
    ),
    "queue_status_ml_table": (
        "lang_code",
        "queue_status_id",
        "queue_status_ml_id",
        "title"
    ),
    "reaction_category_ml_table": (
        "description",
        "id",
        "is_test_data",
        "lang_code",
        "reaction_category_id",
        "title"
    ),
    "reaction_category_table": (
        "reaction_category_id"
    ),
    "reaction_ml_general_view": (
        "image",
        "is_main",
        "is_test_data",
        "lang_code",
        "reaction.title",
        "reaction_category_id",
        "reaction_category_ml.title",
        "reaction_id",
        "reaction_type_id",
        "text",
        "title",
        "value"
    ),
    "reaction_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "identifier",
        "is_description_approved",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "reaction_id",
        "reaction_ml_id",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "reaction_ml_view": (
        "description",
        "image",
        "lang_code",
        "reaction_id",
        "reaction_ml_id",
        "reaction_type_id",
        "title",
        "value"
    ),
    "reaction_ml_view_old": (
        "description",
        "image",
        "lang_code",
        "reaction_id",
        "reaction_ml_id",
        "reaction_table.is_test_data",
        "reaction_type_id",
        "text",
        "title",
        "updated_timestamp",
        "value"
    ),
    "reaction_ml_with_deleted_and_test_data_view": (
        "image",
        "lang_code",
        "reaction.is_test_data",
        "reaction.title",
        "reaction_category_id",
        "reaction_category_ml.is_test_data",
        "reaction_category_ml.lang_code",
        "reaction_category_ml.title",
        "reaction_id",
        "reaction_ml.is_test_data",
        "reaction_type_id",
        "reaction_type_ml.is_test_data",
        "reaction_type_ml.lang_code",
        "text",
        "title",
        "value"
    ),
    "reaction_reaction_category_table": (
        "reaction_category_id",
        "reaction_id",
        "reaction_reaction_category_id"
    ),
    "reaction_review_view": (
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "reaction_id",
        "reaction_ml_id",
        "title"
    ),
    "reaction_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "image",
        "is_test_data",
        "name",
        "number",
        "reaction_id",
        "reaction_type_id",
        "start_timestamp",
        "text",
        "updated_timestamp",
        "updated_user_id",
        "value"
    ),
    "reaction_type_ml_general_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "image",
        "is_test_data",
        "lang_code",
        "name",
        "number",
        "reaction_id",
        "reaction_type_id",
        "reaction_type_ml.end_timestamp",
        "reaction_type_ml.is_test_data",
        "start_timestamp",
        "text",
        "title",
        "updated_timestamp",
        "updated_user_id",
        "value"
    ),
    "reaction_type_ml_table": (
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "is_test_data",
        "lang_code",
        "reaction_type_id",
        "reaction_type_ml_id",
        "start_timestamp",
        "title",
        "updated_timestamp",
        "updated_user_id"
    ),
    "reaction_type_ml_view": (
        "lang_code",
        "name",
        "reaction_type_id",
        "title"
    ),
    "reaction_type_ml_with_deleted_and_test_data_view": (
        "end_timestamp",
        "is_test_data",
        "lang_code",
        "name",
        "reaction_type_id",
        "reaction_type_ml.end_timestamp",
        "reaction_type_ml.is_test_data",
        "title"
    ),
    "reaction_type_table": (
        "end_timestamp",
        "is_test_data",
        "name",
        "reaction_type_id"
    ),
    "reaction_type_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "image",
        "is_test_data",
        "name",
        "number",
        "reaction_id",
        "reaction_type_id",
        "start_timestamp",
        "text",
        "updated_timestamp",
        "updated_user_id",
        "value"
    ),
    "smartlink_table": (
        "action_id",
        "campaign_id",
        "clicked_timestamp",
        "content_message_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "dialog_workflow_script_id",
        "end_timestamp",
        "from_contact_id",
        "from_email_address_id",
        "from_email_address_old",
        "from_normalized_phone",
        "from_person_id",
        "from_phone_id",
        "from_profile_id",
        "from_user_id",
        "identifier",
        "is_test_data",
        "lang_code",
        "message_template_id",
        "number",
        "smartlink_id",
        "smartlink_message_id",
        "smartlink_type_id",
        "start_timestamp",
        "to_contact_id",
        "to_email_address_id",
        "to_email_address_old",
        "to_group_id",
        "to_normalized_phone_old",
        "to_person_id",
        "to_phone_id",
        "to_profile_id",
        "to_user_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url_redirect"
    ),
    "smartlink_type_general_view": (
        "action_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "dialog_workflow_script_id",
        "dialog_workflow_script_id_old",
        "end_timestamp",
        "expiration_unit",
        "expiration_value",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "smartlink_type_id",
        "start_state_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "smartlink_type_table": (
        "action_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "dialog_workflow_script_id_old",
        "end_timestamp",
        "expiration_unit",
        "expiration_value",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "smartlink_type_id",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url_redirect_template"
    ),
    "smartlink_type_view": (
        "action_id",
        "dialog_workflow_script_id_old",
        "expiration_unit",
        "expiration_value",
        "is_test_data",
        "name",
        "smartlink_type_id",
        "url_redirect_template"
    ),
    "smartlink_view": (
        "action_id",
        "campaign_id",
        "clicked_timestamp",
        "content_message_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "dialog_workflow_script_id",
        "end_timestamp",
        "from_contact_id",
        "from_email_address_id",
        "from_email_address_old",
        "from_normalized_phone",
        "from_person_id",
        "from_phone_id",
        "from_profile_id",
        "from_user_id",
        "identifier",
        "is_test_data",
        "lang_code",
        "message_template_id",
        "number",
        "smartlink_id",
        "smartlink_message_id",
        "smartlink_type_id",
        "start_timestamp",
        "to_contact_id",
        "to_email_address_id",
        "to_email_address_old",
        "to_group_id",
        "to_normalized_phone_old",
        "to_person_id",
        "to_phone_id",
        "to_profile_id",
        "to_user_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url_redirect"
    ),
    "star_transaction_table": (
        "action_id",
        "action_stars",
        "activity_type_id",
        "api_type_id",
        "balance_after_transaction",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "invitation_id",
        "is_test_data",
        "number",
        "person_id",
        "profile_id",
        "star_transaction_id",
        "start_timestamp",
        "subscription_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_id"
    ),
    "star_transaction_view": (
        "action_id",
        "action_stars",
        "activity_type_id",
        "api_type_id",
        "balance_after_transaction",
        "identifier",
        "is_test_data",
        "number",
        "person_id",
        "star_transaction_id",
        "subscription_id",
        "user_id"
    ),
    "file_extension_table": (
        "ext",
        "file_extension_id",
        "name"
    ),
    "file_type_ml_table": (
        "description",
        "file_type_id",
        "file_type_ml_id",
        "is_description_approved",
        "is_main",
        "is_title_approved",
        "lang_code",
        "title"
    ),
    "file_type_ml_view": (
        "description",
        "file_type_id",
        "file_type_ml_id",
        "is_description_approved",
        "is_main",
        "is_title_approved",
        "lang_code",
        "title"
    ),
    "file_type_table": (
        "add_action_id",
        "file_type",
        "file_type_id",
        "remove_action_id"
    ),
    "file_type_view": (
        "file_type",
        "file_type_id"
    ),
    "storage_recent_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "ext",
        "file_extension.name",
        "file_extension_id",
        "file_type",
        "file_type_id",
        "file_type_ml.title",
        "filename",
        "height",
        "path",
        "ratio_x",
        "ration_y",
        "region",
        "start_timestamp",
        "stoage.is_test_data",
        "storage_id",
        "storage_type_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "width"
    ),
    "storage_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "file_extension_id",
        "file_type_id",
        "filename",
        "height",
        "is_test_data",
        "path",
        "ratio_x",
        "ration_y",
        "region",
        "start_timestamp",
        "storage_id",
        "storage_type_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "width"
    ),
    "storage_view": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "file_extension_id",
        "file_type_id",
        "filename",
        "height",
        "is_test_data",
        "path",
        "ratio_x",
        "ration_y",
        "region",
        "start_timestamp",
        "storage_id",
        "storage_type_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "width"
    ),
    "subscription_user_profile_action_limit_table": (
        "action_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "hard_limit_value",
        "limit_unit",
        "profile_id",
        "soft_limit_value",
        "start_timestamp",
        "subscription_id",
        "subscription_profile_action_limit_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "test_county_ml_table": (
        "county_id",
        "county_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_county_ml_with_deleted_and_test_data_view": (
        "county_id",
        "county_ml_id",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "state_id",
        "title",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_county_table": (
        "coordinate",
        "country_id",
        "county_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group_id",
        "is_test_data",
        "name",
        "number",
        "state_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "test_location_profile_ml_table": (
        "lang_code",
        "test_location_profile_id",
        "test_location_profile_ml_id",
        "title",
        "title_approved"
    ),
    "test_location_profile_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "location_id",
        "profile_id",
        "start_timestamp",
        "test_location_profile_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "test_mysql_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_main",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "test_mysql_id",
        "test_mysql_ml_id",
        "title",
        "unique_int_column",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_mysql_ml_view": (
        "created_effective_profile_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_main",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "test_mysql_id",
        "test_mysql_ml_id",
        "title",
        "unique_int_column",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_mysql_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "point",
        "polygon",
        "start_timestamp",
        "test_mysql_id",
        "unique_int_column",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_mysql_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "group",
        "identifier",
        "is_test_data",
        "name",
        "number",
        "point",
        "polygon",
        "start_timestamp",
        "test_mysql_id",
        "unique_int_column",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_mysql_without_is_main_ml_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "test_mysql_id",
        "test_mysql_ml_id",
        "title",
        "unique_int_column",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_mysql_without_is_main_ml_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "is_title_approved",
        "lang_code",
        "number",
        "start_timestamp",
        "test_mysql_id",
        "test_mysql_ml_id",
        "title",
        "unique_int_column",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "visibility_id"
    ),
    "test_orm_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "test_orm_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "test_typeorm_ml_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "is_title_approved",
        "lang_code",
        "start_timestamp",
        "test_typeorm_id",
        "test_typeorm_ml_id",
        "title",
        "unique_int_column",
        "updated_timestamp",
        "updated_user_id"
    ),
    "test_typeorm_table": (
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "start_timestamp",
        "test_typeorm_id",
        "unique_int_column",
        "updated_timestamp",
        "updated_user_id"
    ),
    "text_block_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "effective_timestamp",
        "end_timestamp",
        "fields_extracted_json",
        "identifier",
        "is_test_data",
        "number",
        "profile_id",
        "seq",
        "start_timestamp",
        "system_entity_id",
        "system_id",
        "text",
        "text_block_id",
        "text_block_type_id",
        "text_without_empty_lines",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "visibility_id"
    ),
    "text_block_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "fields_extracted_json",
        "identifier",
        "number",
        "profile_id",
        "seq",
        "start_timestamp",
        "system_entity_id",
        "system_id",
        "text",
        "text_block_id",
        "text_block_type_id",
        "text_without_empty_lines",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "visibility_id"
    ),
    "text_block_type_general_view": (
        "lang_code",
        "name",
        "regex",
        "system_entity_id",
        "system_id",
        "text_block_type_id",
        "text_block_type_name",
        "text_block_type_regex_regex"
    ),
    "text_block_type_ml_en_view": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "is_description_approved",
        "is_name_approved",
        "lang_code",
        "name",
        "regex",
        "start_timestamp",
        "system_entity_id",
        "system_id",
        "text_block_type_id",
        "text_block_type_ml_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "text_block_type_ml_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "is_description_approved",
        "is_name_approved",
        "lang_code",
        "name",
        "start_timestamp",
        "text_block_type_id",
        "text_block_type_ml_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "text_block_type_ml_view": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "is_description_approved",
        "is_name_approved",
        "lang_code",
        "name",
        "regex",
        "start_timestamp",
        "system_entity_id",
        "system_id",
        "text_block_type_id",
        "text_block_type_ml_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "text_block_type_regex_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "lang_code",
        "regex",
        "start_timestamp",
        "text_block_type_id",
        "text_block_type_regex_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "text_block_type_regex_view": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "description",
        "end_timestamp",
        "lang_code",
        "regex",
        "start_timestamp",
        "text_block_type_id",
        "text_block_type_regex_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "text_block_type_table": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "name",
        "regex",
        "start_timestamp",
        "system_entity_id",
        "system_id",
        "text_block_type_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "text_block_type_view": (
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "regex",
        "start_timestamp",
        "system_entity_id",
        "system_id",
        "text_block_type_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id"
    ),
    "url_table": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "normalized_url",
        "number",
        "start_timestamp",
        "storage_id",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "url_id",
        "url_type"
    ),
    "url_view": (
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "end_timestamp",
        "identifier",
        "is_test_data",
        "number",
        "start_timestamp",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url",
        "url_id",
        "url_type"
    ),
    "user_age_range": (
        "age_max",
        "age_min",
        "user_id"
    ),
    "user_language": (
        "lang_code_id",
        "user_id"
    ),
    "user_list_member_table": (
        "id",
        "user_id",
        "user_list_id"
    ),
    "user_list_old": (
        "id"
    ),
    "user_list_table": (
        "id"
    ),
    "user_not_deleted_view": (
        "active_location_id",
        "brand_id",
        "created_timestamp",
        "created_user_id",
        "current_time_zone",
        "default_time_zone",
        "end_timestamp",
        "first_name",
        "gender_id",
        "identity_id",
        "interested_in_gender_id",
        "is_approved",
        "is_test_data",
        "last_name",
        "main_email",
        "name_approved",
        "number",
        "password",
        "password_clear_text",
        "password_encrypted",
        "preferred_lang_code",
        "presence",
        "region",
        "stars",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_approval_to_get_emails_from_us",
        "user_id",
        "user_main_email_address",
        "username"
    ),
    "user_review_users_with_same_main_email_address_view": (
        "active_location_id",
        "birthday_moved_to_person",
        "birthday_original_moved_to_person",
        "brand_id",
        "created_timestamp",
        "created_user_id",
        "current_time_zone",
        "default_time_zone",
        "end_timestamp",
        "first_name",
        "gender_id",
        "identity_id",
        "interested_in_gender_id",
        "is_approved",
        "is_system",
        "is_test_data",
        "last_name",
        "main_email",
        "name_approved",
        "number",
        "password",
        "preferred_lang_code",
        "presence",
        "region",
        "stars",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_approval_to_get_emails_from_us",
        "user_id",
        "username"
    ),
    "user_status_history_table": (
        "end_timestamp",
        "id",
        "start_timestamp",
        "user_status_id"
    ),
    "user_status_ml_table": (
        "id",
        "lang_code",
        "title",
        "user_status_id"
    ),
    "user_status_table": (
        "id"
    ),
    "user_table": (
        "active_location_id",
        "birthday_moved_to_person",
        "birthday_original_moved_to_person",
        "brand_id",
        "created_timestamp",
        "created_user_id",
        "current_time_zone",
        "default_time_zone",
        "end_timestamp",
        "first_name",
        "gender_id",
        "identity_id",
        "interested_in_gender_id",
        "is_approved",
        "is_system",
        "is_test_data",
        "last_name",
        "main_email",
        "main_profile_id",
        "name_approved",
        "number",
        "password",
        "preferred_lang_code",
        "presence",
        "region",
        "stars",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_approval_to_get_emails_from_us",
        "user_id",
        "username"
    ),
    "user_to_be_reviewed_view": (
        "active_location_id",
        "birthday_moved_to_person",
        "birthday_original_moved_to_person",
        "brand_id",
        "created_timestamp",
        "created_user_id",
        "current_time_zone",
        "default_time_zone",
        "end_timestamp",
        "first_name",
        "gender_id",
        "identity_id",
        "interested_in_gender_id",
        "is_approved",
        "is_test_data",
        "last_name",
        "main_email",
        "name_approved",
        "number",
        "password",
        "preferred_lang_code",
        "presence",
        "region",
        "stars",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_approval_to_get_emails_from_us",
        "user_id",
        "username"
    ),
    "user_to_delete_view": (
        "is_system",
        "is_test_data",
        "user_id"
    ),
    "user_view": (
        "active_location_id",
        "brand_id",
        "created_timestamp",
        "created_user_id",
        "current_time_zone",
        "default_time_zone",
        "end_timestamp",
        "first_name",
        "gender_id",
        "identity_id",
        "interested_in_gender_id",
        "is_approved",
        "is_test_data",
        "last_name",
        "main_email",
        "name_approved",
        "number",
        "password",
        "password_clear_text",
        "password_encrypted",
        "preferred_lang_code",
        "presence",
        "region",
        "stars",
        "start_timestamp",
        "updated_timestamp",
        "updated_user_id",
        "user_approval_to_get_emails_from_us",
        "user_id",
        "user_main_email_address",
        "username"
    ),
    "user_external_email_account_general_view": (
        "access_token",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "email_account_id",
        "email_account_name",
        "email_address_id",
        "end_timestamp",
        "environment_id_old",
        "expiry",
        "handle",
        "is_test_data",
        "number",
        "oauth_callback_confirmed",
        "oauth_token",
        "oauth_token_secret",
        "refresh_token",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "token_2delete",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "username"
    ),
    "user_external_general_view": (
        "access_token",
        "created_timestamp",
        "created_user_id",
        "email_address_id",
        "end_timestamp",
        "environment_id_old",
        "expiry",
        "handle",
        "is_test_data",
        "number",
        "oauth_callback_confirmed",
        "oauth_token",
        "oauth_token_secret",
        "refresh_token",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "token_2delete",
        "updated_timestamp",
        "updated_user_id",
        "user_external_id",
        "username"
    ),
    "user_external_table": (
        "access_token",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "credential_storage_id",
        "email_address_id",
        "end_timestamp",
        "environment_id_old",
        "expiry",
        "handle",
        "identifier",
        "is_refresh_token_valid",
        "is_test_data",
        "main_profile_id",
        "number",
        "oauth_callback_confirmed",
        "oauth_state",
        "oauth_token",
        "oauth_token_secret",
        "refresh_token",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "token_2delete",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url_id",
        "user_external_id",
        "username"
    ),
    "user_external_view": (
        "access_token",
        "created_effective_profile_id",
        "created_effective_user_id",
        "created_real_user_id",
        "created_timestamp",
        "created_user_id",
        "credential_storage_id",
        "email_address_id",
        "end_timestamp",
        "environment_id_old",
        "expiry",
        "handle",
        "identifier",
        "is_refresh_token_valid",
        "is_test_data",
        "main_profile_id",
        "number",
        "oauth_callback_confirmed",
        "oauth_state",
        "oauth_token",
        "oauth_token_secret",
        "refresh_token",
        "start_timestamp",
        "subsystem_id",
        "system_id",
        "token_2delete",
        "updated_effective_profile_id",
        "updated_effective_user_id",
        "updated_real_user_id",
        "updated_timestamp",
        "updated_user_id",
        "url_id",
        "user_external_id",
        "username"
    )
}